#include <qpainter.h>
#include <qfileinfo.h>

#include "base.h"
#include "barreEtat.h"
#include "couleurs.h"

barreEtat::barreEtat(QWidget * parent, char * name)
  : QWidget(parent,name)
{
  touche= new QString("");
  texte = new QString("");
  nomfic= new QString("");
  t1    = new QString("");
  t2    = new QString("");
  t3    = new QString("");

  buffer= new QPixmap();
  modif = false;
  b1=b2=b3=false;
  setBackgroundColor(C_BE_FOND);
}

barreEtat::~barreEtat()
{
  delete buffer;
  delete nomfic;
  delete texte;
  delete touche;
  delete t1;
  delete t2;
  delete t3;
}

void barreEtat::setBoutons(bool & nb1, bool & nb2, bool & nb3)
{
  //  if (nb1 && nb3) nb2=true;
  //  if (nb2) nb1=nb3=false;

  if (nb1==b1 && nb2==b2 && nb3==b3)
    return;

  b1=nb1;
  b2=nb2;
  b3=nb3;

  repaint(false);
}

void barreEtat::setMouseInfos(QString nt1, QString nt2, QString nt3)
{
  if (nt1==*t1 && nt2==*t2 && nt3==*t3)
    return;

  *t1 = nt1;
  *t2 = nt2;
  *t3 = nt3;

  repaint(false);
}

void barreEtat::resizeEvent(QResizeEvent * re)
{
  buffer->resize(re->size());
}

void barreEtat::boite(QPainter & p, int x1, int y1,int w, int h, QString s, int tf, bool cadre)
{
  int x2= x1+w-1;
  int y2= y1+h-1;

  if (cadre)
    {
	 p.setPen(backgroundColor().dark (120));
	 p.drawLine(x1  ,y1  ,x2-1,y1  );
	 p.drawLine(x1  ,y1  ,x1  ,y2-1);
	 p.setPen(backgroundColor().dark (150));
	 p.drawLine(x1+1,y1+1,x2-2,y1+1);
	 p.drawLine(x1+1,y1+1,x1+1,y2-2);
	 p.setPen(backgroundColor().light(150));
	 p.drawLine(x1  ,y2  ,x2  ,y2  );
	 p.drawLine(x2  ,y1  ,x2  ,y2  );
	 p.setPen(backgroundColor().light(200));
	 p.drawLine(x1+1,y2-1,x2-1,y2-1);
	 p.drawLine(x2-1,y1+1,x2-1,y2-1);
    }

  p.setPen(C_BE_TEXTE);
  int dy= p.fontMetrics().ascent() + (y2-y1+1-p.fontMetrics().lineSpacing())/2;
  int dx= 4;
  p.drawText(x1+dx,y1+2,x2-x1-2*dx,y2-y1-6, tf | AlignVCenter,s);
}

void barreEtat::paintEvent(QPaintEvent * pe)
{
  QPainter p;
  //-------------------------
  p.begin(buffer);
  p.fillRect(0,0,width(),height(),backgroundColor());

  p.setFont(QFont("Fixed",10));

  QString m;
  m.sprintf("-%c- %s",modif?'*':'-',*nomfic==""?"<sans nom>":(const char *) QFileInfo(*nomfic).fileName());

#define W1 (46)
#define W2 (200)
#define W3 (width()-(W1+W2))
#define H1 (height()/2)
#define H2 (height()-H1)
  boite(p,    0, 0,W1   ,H1   ,*touche         ,AlignHCenter);
  boite(p,   W1, 0,W2   ,H1   ,*texte          ,AlignLeft   );
  boite(p,    0,H1,W1+W2,H2   ,(const char *) m,AlignLeft   );
  boite(p,W1+W2, 0,W3   ,H1+H2,""              ,AlignLeft   );

#define L  (H2-5)
#define X0 (W1+W2+(W3-3*L)/2)
  QColor c;

  c= C_BE_BOUTONS; if (*t1=="") c= c.dark(300);
  p.setPen(c); p.drawRect(X0+0*L,H1,L-1,L-1);
  if (b1) p.fillRect(X0+0*L+2,H1+2,L-5,L-5,c);

  c= C_BE_BOUTONS; if (*t2=="") c= c.dark(300);
  p.setPen(c); p.drawRect(X0+1*L,H1,L-1,L-1);
  if (b2) p.fillRect(X0+1*L+2,H1+2,L-5,L-5,c);

  c= C_BE_BOUTONS; if (*t3=="") c= c.dark(300);
  p.setPen(c); p.drawRect(X0+2*L,H1,L-1,L-1);
  if (b3) p.fillRect(X0+2*L+2,H1+2,L-5,L-5,c);

#define LL ((W3-3*L)/2)
  boite(p,W1+W2      , 0,W3,H1,*t2,AlignHCenter,false);
  boite(p,W1+W2      ,H1,LL,H1,*t1,AlignRight  ,false);
  boite(p,W1+W2+W3-LL,H1,LL,H1,*t3,AlignLeft   ,false);
#undef LL

#undef X0
#undef L

#undef H2
#undef H1
#undef W2
#undef W1

  p.end();
  //-------------------------
  p.begin(this);
  p.drawPixmap(0,0,*buffer);
  p.end();
}

void barreEtat::setMessage(QString k, QString t)
{
  if (k!=*touche || t!=*texte)
    {
	 *touche= k;
	 *texte = t;
	 repaint(false);
    }
}

QString barreEtat::getNomFic()
{
  return *nomfic;
}

void barreEtat::setNomFic(QString nf)
{
  if (*nomfic != nf)
    {
	 *nomfic= nf;
	 repaint(false);
    }
}

bool barreEtat::getModifiee()
{
  return modif;
}

void barreEtat::setModifiee(bool b)
{
  if (b!=modif)
    {
	 modif=b;
	 repaint(false);
    }
}
