#include <qpainter.h>
#include <qpixmap.h>

#include "base.h"
#include "barreInfos.h"
#include "couleurs.h"

barreInfos::barreInfos(QWidget * parent)
  : QWidget(parent)
{
  nbBrins= nbSommets= epaisseur= bps= 0;

  buffer= new QPixmap;
  setBackgroundColor(C_BI_FOND);
}

barreInfos::~barreInfos()
{
  delete buffer;
}

void barreInfos::resizeEvent(QResizeEvent * re)
{
  buffer->resize(re->size());
}

void barreInfos::setInfos(int b,int s,int e,int t)
{
  if (b==nbBrins && s==nbSommets && e==epaisseur && t==bps)
    return;

  nbBrins  = b;
  nbSommets= s;
  epaisseur= e;
  bps      = t;

  repaint(false);
}

void barreInfos::paintEvent(QPaintEvent * pe)
{
  QPainter p;
  //-------------------------
  p.begin(buffer);
  p.fillRect(0,0,width(),height(),backgroundColor());

  int w= width()-1, h= height()-1, delta= 10;

  p.setPen(C_BI_BORD);
  p.drawLine(0,0,w,0);
  p.drawLine(0,0,0,h);
  p.drawLine(w,0,w,h);
  p.drawLine(0,h,w,h);

  p.setFont(QFont("Fixed",10));
  p.setPen(C_BI_TEXTE);
  
  QString sb; sb.sprintf("< Brins  : %4d >"  , nbBrins  );
  QString ss; ss.sprintf("< Sommets: %4d >"  , nbSommets);
  QString se; se.sprintf("< Epaisseur: %3d >", epaisseur);

  int hl= p.fontMetrics().height();

  p.drawText(delta,1*hl,sb);
  p.drawText(delta,2*hl,ss);
  
  p.setPen(C_SBRIN);

  if (epaisseur!=0)
    p.drawText(w-delta-p.fontMetrics().width(se),1*hl,se);

  if (bps!=0)
    {
	 QString sl;
	 sl.sprintf("< Brins/Sommet: %3d >",bps);
	 
	 p.drawText(width()-delta-p.fontMetrics().width(sl),2*hl,sl);
    }

  p.end();
  //-------------------------
  p.begin(this);
  p.drawPixmap(0,0,*buffer);
  p.end();
}
