#include <qapplication.h>
#include <qspinbox.h>
#include <qpixmap.h>
#include <qpainter.h>

#include "base.h"
#include "boitounette.h"

boitounette::boitounette(int min, int max, int pas, QWidget * pere, const char * nom)
  : QWidget(pere,nom)
{
  sb= new QSpinBox(min,max,pas,this);

  grab=false;
  pm= new QPixmap;
  connect(sb,SIGNAL(valueChanged(int)),this,SLOT(slotValueChanged(int)));
}

void boitounette::slotValueChanged(int i)
{
  emit valueChanged(i);
}

boitounette::~boitounette()
{
  delete pm;
  delete sb;
}

void boitounette::paintEvent(QPaintEvent * pe)
{
  QPainter p;
  p.begin(this);
  p.drawPixmap(0,0,*pm);
  p.end();
}

void boitounette::resizeEvent(QResizeEvent * re)
{
  int
    w= re->size().width (),
    h= re->size().height();

  sb->setGeometry(0,2*h/3,w,h-2*h/3);
}

void boitounette::setValeur(int i)
{
  sb->setValue(i);
}

void boitounette::setPixmap(QPixmap p)
{
  *pm=p;
}

int boitounette::valeur()
{
  return sb->value();
}

void boitounette::mousePressEvent(QMouseEvent * me)
{
  grab=true;
  memo     = me->globalPos();
  memoValue= valeur();
}

void boitounette::mouseReleaseEvent(QMouseEvent * me)
{
  grab=false;
}

#define K (2)
void boitounette::mouseMoveEvent(QMouseEvent * me)
{
  if (grab)
    setValeur(memoValue +
		    (me->globalX()-memo.x())/K -
		    (me->globalY()-memo.y())/K );
}
