#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlabel.h>

#include "base.h"
#include "dialogXYZ.h"

dialogXYZ::dialogXYZ(QWidget * parent, char * name): QDialog(parent, name, true)
{
  setCaption(name);
  lx = new QLabel(this); lx->setText("X="); x= new QLineEdit(this); x->setText("0");
  ly = new QLabel(this); ly->setText("Y="); y= new QLineEdit(this); y->setText("0");
  lz = new QLabel(this); lz->setText("Z="); z= new QLineEdit(this); z->setText("0");

  ok     = new QPushButton("&Valider",this);
  cancel = new QPushButton("&Annuler",this);

#define LL ( 30) // Longueur des labels.
#define LE (100) // Longueur des boites d'dition.
#define HL ( 30) // Hauteur de chaque ligne

  lx->setGeometry(0,0*HL,LL,HL); x->setGeometry(LL,0*HL,LE,HL);
  ly->setGeometry(0,1*HL,LL,HL); y->setGeometry(LL,1*HL,LE,HL);
  lz->setGeometry(0,2*HL,LL,HL); z->setGeometry(LL,2*HL,LE,HL);

  cancel->setGeometry(        0,4*HL, (LL+LE)/2,HL);
  ok    ->setGeometry((LL+LE)/2,4*HL, (LL+LE)/2,HL);

  connect(ok    , SIGNAL(clicked()), SLOT(clicOK()));
  connect(cancel, SIGNAL(clicked()), SLOT(reject()));

#undef LL
#undef LE
#undef HL

  setFixedSize(ok->geometry().right(),ok->geometry().bottom());
}

dialogXYZ::~dialogXYZ()
{
  delete  x; delete  y; delete  z;
  delete lx; delete ly; delete lz;

  delete ok; delete cancel;
}

void dialogXYZ::clicOK()
{
  coord xx ,yy ,zz ;
  bool  xOk,yOk,zOk;

  xx= QString(x->text()).toDouble(&xOk);
  yy= QString(y->text()).toDouble(&yOk);
  zz= QString(z->text()).toDouble(&zOk);

  if (xOk && yOk && zOk)
    {
	 emit ajouteBrin(new sommet(xx,yy,zz));
	 accept();
    }
}
