#include <qpainter.h>
#include <qpixmap.h>

#include "base.h"
#include "dialogue.h"

dialogue::dialogue(QWidget * parent, char * name,
			    char * s1, unsigned int m1, unsigned int M1, unsigned int v1, const char * p1[],
			    char * s2, unsigned int m2, unsigned int M2, unsigned int v2, const char * p2[],
			    bool slider)
  : QWidget(parent,name,WStyle_Customize|WStyle_Tool)
{
  setCaption(name);
  
  L1= new QLabel(s1,this);
  L1->setAlignment(AlignCenter);
  B1= new boitounette(m1,M1,1,this);
  B1->setValeur(v1);
  B1->setPixmap(QPixmap(p1));
  
  if (s2==NULL)
    {
	 L2 = NULL; L3 = NULL;
	 B2 = NULL; S  = NULL;
	 
	 unsigned int w1= 76, w2= 48, h1=20, h2= 72;
	 place(L1,0,0,w1,h1);
	 place(B1,(w1-w2)/2,h1,w2,h2);
	 
	 setFixedSize(w1,h1+h2);
    }
  else
    {
	 L2= new QLabel(s2,this);
	 L2->setAlignment(AlignCenter);
	 B2= new boitounette(m2,M2,1,this); B2->setValeur(v2);
	 B2->setPixmap(QPixmap(p2));
	 
	 unsigned int w1= 80, w2= 48, h1= 20, h2= 72;
	 place(L1, 0,0,w1,h1); place(B1, 0+(w1-w2)/2,h1,w2,h2);
	 place(L2,w1,0,w1,h1); place(B2,w1+(w1-w2)/2,h1,w2,h2);

	 if (!slider)
	   {
		L3 = NULL;
		S  = NULL; 
		setFixedSize(w1+w1,h1+h2);	
	   }
	 else
	   {
		L3= new QLabel(" 0 <-        r/R         -> 1",this);
		L3->setAlignment(AlignCenter);
		S = new QSlider(1,100,10,0,QSlider::Horizontal,this);
		
		connect(S,SIGNAL(valueChanged(int)),this,SLOT(valueSliderChanged(int)));
		S->setTickmarks(QSlider::Both);
		S->setTickInterval(10);
		S->setValue(20);

		unsigned int h3= h1, h4= 30;
		place(L3, 0,h1+h2,w1+w1,h3);
		place(S , 0,h1+h2+h3,w1+w1,h4);

		setFixedSize(w1+w1,h1+h2+h3+h4);
	   }
    }
}

dialogue::~dialogue()
{
  if (L1!=NULL) delete L1;
  if (L2!=NULL) delete L2;
  if (L3!=NULL) delete L3;

  if (B1!=NULL) delete B1;
  if (B2!=NULL) delete B2;
  if (S !=NULL) delete S ;
}
//-----------------------------------------------------------------------------------
#define HTITLE (20)
#define DX     (3)
#define DY     (3)

void dialogue::setFixedSize(unsigned int x, unsigned int y)
{
  QWidget::setFixedSize(DX+DX+x,DY+DY+HTITLE+y);
}

void dialogue::place(QWidget * W,
				 unsigned int x, unsigned int y,
				 unsigned int w, unsigned int h)
{
  W->setGeometry(DX+x,DY+HTITLE+y,w,h);
}
//.........................................
void dialogue::paintEvent(QPaintEvent * pe)
{
  unsigned int w= width ()-1;
  unsigned int h= height()-1;

  QPainter p;
  p.begin(this);

  p.fillRect(1,1,w-1,HTITLE-1,QColor(20,20,20));
  p.setPen(white);
  p.drawText(1,1,w-1,HTITLE-1,AlignCenter,caption());
  p.drawLine(0,0,w,0);
  p.drawLine(w,0,w,h);
  p.drawLine(w,h,0,h);
  p.drawLine(0,h,0,0);
  p.drawLine(0,HTITLE,w,HTITLE);
  p.end();
}
//-----------------------------------------------------------------------------------
void dialogue::valueSliderChanged(int n)
{
  vSlider = ((coord) n)/100;
}

unsigned int dialogue::meridiens ()
{
  return B1->valeur();
}

unsigned int dialogue::paralleles()
{
  if (!B2)
    erreur("dialogue: Impossible d'accder  la valeur 'paralleles'.");

  return B2->valeur();
}

coord dialogue::grandRayon()
{
  if (!S)
    erreur("dialogue: Impossible d'accder  la valeur 'grandRayon'.");

  return 1;
}

coord dialogue::petitRayon()
{
  if (!S)
    erreur("dialogue: Impossible d'accder  la valeur 'petitRayon'.");

  return vSlider;
}
