#ifndef _ensemble_h
#define _ensemble_h

#include <qobject.h>
#include <qintdict.h>
#include <qlist.h>

// QT ne supporte pas les templates...
class ensemble: public QObject
{
 Q_OBJECT

 private:
   QIntDict<QObject> * d;
   QList   <QObject> * l;
   void creation();
   long int cle(const QObject *) const;

 public:
   ensemble();
   ensemble(const ensemble &);
   ~ensemble();

   bool       contient        (const QObject  *) const;
   bool       contientEnsemble(const ensemble &) const;
   ensemble & enleve          (const QObject  *);
   ensemble & enleveEnsemble  (const ensemble &);
   ensemble & ajoute          (const QObject  *); // adjonction en FIN de liste
   ensemble & ajouteEnsemble  (const ensemble &);
   bool       estVide         (                ) const;
   ensemble & vide            (bool =false     );
   QObject  * choisis         (                );

   QObject  * premier  (               ) const;
   QObject  * suivant  (const QObject *) const;
   QObject  * dernier  (               ) const;
   QObject  * precedant(const QObject *) const;

   unsigned int taille() const;

   ensemble & operator= (const ensemble &);
};

#endif
