// Mthodes d'extrusion :      27-31/03/2000 - 11/05/2000
// ********************           

#include <math.h>    

/* Renvoie 1 si le brin appartient  un sommet seul.  
   2 si le brin appartient  une arte seule.
   3 si le brin appartient  un groupe d'artes.
   4 si le brin appartient  une face seule.
   5 si le brin appartient  un volume. */
int gcarte::app_safv(brin *b)
{
  
  brin *bb;
  ensemble fbrin;
  
// S'il n'y a qu'un sommet :
  if (b->getAlpha(0)==b)
    return(1);
  
  fbrin = orbiteFace(b);
  
// S'il n'y a que deux brins, on a une arte.
  if(fbrin.taille()==2)
    return(2);
  
// Si un brin n'a pas de Alpha 1, on est dans un groupe d'artes.
  b=(brin *) fbrin.premier();
  while (b != NULL)
    {
	 if (b->getAlpha(1)==b)
	   return(3);
	 b=(brin *) fbrin.suivant(b);
    }
  
// Si un brin a un Alpha 2, on est dans un volume.
  b=(brin *) fbrin.premier();
  while (b != NULL)
    {
	 if (b->getAlpha(2)!=b)
	   return(5);
	 b=(brin *) fbrin.suivant(b);
    }
  
  return(4);
}


/* Calcul du vecteur normal  une face :
*********************************** 
sommet * gcarte::vecteurnormal(ensemble som, sommet *v, brin *br)
{
int k=1;
// On prend trois sommets de la face afin de calculer l'quation du plan qu'elle forme.
sommet *s1, *s2, *s3;
s1 = (sommet *) som.premier();
s2 = (sommet *) som.suivant(s1);
s3 = (sommet *) som.suivant(s2);

double a, b, c, a1, b1, c1, a2, b2, c2;

// Coordonnes des vecteurs forms par les sommets 2  2 :
a1 = s1->getx()-s2->getx();
b1 = s1->gety()-s2->gety();
c1 = s1->getz()-s2->getz();
a2 = s3->getx()-s2->getx();
b2 = s3->gety()-s2->gety();
c2 = s3->getz()-s2->getz();

a = b1*c2-b2*c1;
b = a2*c1-a1*c2;
c = a1*b2-a2*b1;

ensemble ensbrin;
ensbrin = sommets(br);         // ensemble des brins du volume dont on extrude une face.     
// On remplit l'ensemble som avec les sommets de la face  extruder.
// ----------------------------------------------------------------
br = (brin *) ensbrin.premier();
// On parcourt les brins de la face.
while (br!=NULL)
{
// On ajoute le sommet courant  som.
som.ajoute((sommet*) br->getSommet());
br = (brin *) ensbrin.suivant(br);         // On passe au suivant.    
}
cout<<"Nb de sommets : "<<som.taille()<<endl;

sommet *s = (sommet *) som.premier();
double xmin=s->getx();
double xmax=s->getx();
double ymin=s->gety();
double ymax=s->gety();
double zmin=s->getz();
double zmax=s->getz();
while (s != NULL)
{     
if (xmin > s->getx())
xmin = s->getx();
if (xmax < s->getx())
xmax = s->getx();

if (ymin > s->gety())
ymin = s->gety();
if (ymax < s->gety())
ymax = s->gety();

if (zmin > s->getz())
zmin = s->getz();
if (zmax < s->getz())
zmax = s->getz();

cout<<s->getz()<<endl;
s = (sommet *) som.suivant(s);

}
cout<<c<<" "<<c+s2->getz()<<"  "<<zmin<<"  "<<zmax<<endl;

if ((c+s2->getz())>=zmin && (c+s2->getz())<=zmax)
c=-c;

// vecteur d'extrusion.
sommet *n = new sommet(a, b, c);

return(n);
}
*/

/* Extrusion selon un vecteur donn :
******************************** 
v donne les 3 composantes du vecteur d'extrusion. */
brin * gcarte::extrusionFace(brin *b, const sommet v, const unsigned int m)
{
  ensemble fbrin , fsommet, nsommet, nbrin;
  brin *bb;
  int objet=app_safv(b);    // objet auquel appartient b (arte, face ou volume).
  fbrin = orbiteFace(b);    // fbrin est l'ensemble des brins de la face contenant le brin b.
  brin *brin_initial = b;
  
  
// Si le brin est dj cousu par alpha 3 => pas d'extrusion possible. On renvoie seulement le brin.
  if (b->getAlpha(3) != b)
    return b;
  
// Si on dsire extruder un sommet:
// *******************************
  if (b->getAlpha(0)==b)
    {
	 sommet *s = (sommet*) b->getSommet();      // On cre un nouveau sommet.
	 sommet * gerard = new sommet(*s + v);
	 
	 bb = ajouteBrin(gerard);      // On ajoute un brin au nouveau sommet.
	 coudre(b,bb);                 // On le coud au sommet initial.
	 return bb ;
    }
  
  
// Si on dsire extruder une arete :
// *******************************
  if (objet==2)
    {
	 brin *b1, *b2, *b3, *b4, *b5, *b6;
	 
// On rcupre les deux brins de l'arte :
	 b = (brin *) fbrin.premier();
	 bb= (brin *) fbrin.suivant(b);
	 
// On rcupre les deux sommets de l'arte :
	 sommet * s  = (sommet*) b->getSommet();
	 sommet * ss = (sommet*) bb->getSommet();
	 
// On cre les deux nouveaux sommets :
	 sommet * s1 = new sommet(*s  + v);
	 sommet * s2 = new sommet(*ss + v);
	 
// On ajoute deux brins  chaque nouveau sommet et un brin aux anciens sommets :
	 b1 = ajouteBrin(s);
	 b2 = ajouteBrin(ss);
	 b3 = ajouteBrin(s1);
	 b4 = ajouteBrin(s1);
	 b5 = ajouteBrin(s2);
	 b6 = ajouteBrin(s2);
	 
// On relie les brins par les Alpha :
	 b1->setAlpha(0,b3);      b3->setAlpha(0,b1);
	 b2->setAlpha(0,b6);      b6->setAlpha(0,b2);
	 b4->setAlpha(0,b5);      b5->setAlpha(0,b4);
	 
	 b->setAlpha(1,b1);       b1->setAlpha(1,b);
	 bb->setAlpha(1,b2);      b2->setAlpha(1,bb);
	 b3->setAlpha(1,b4);      b4->setAlpha(1,b3);
	 b5->setAlpha(1,b6);      b6->setAlpha(1,b5);
	 
	 return b4;
    }


// Si on dsire extruder un groupe d'artes : => Si bouts bien placs sur axe Y => extrusion par rotation !
// ****************************************    
// Le nombre d emridiens est dcids par le meme que la sphre.
if (objet==3)
{
  int i, j, h, u,v,w, n, p;
//  m=10;                          // nb de mridiens qu'aura le volume extrud.
  fbrin = orbiteFace(b);         // fbrin est l'ensemble des brins de la face contenant le brin b.
  
  brin *b_bout1, *b_b1;
  brin *b_bout2, *b_b2;
  sommet *s_bout1;
  sommet *s_bout2;
  
  // On trouve les brins qui sont en bout de chaine (ils ne sont pas cousus par Alpha 1).
  b=(brin*) fbrin.premier();
  while (b != NULL)
    {
      if (b->getAlpha(1)==b)
	{ b_bout1=b; b=NULL;}
      else
	b=(brin *) fbrin.suivant(b);
    }
  
  b=(brin*) fbrin.premier();
  while (b != NULL)
    {
      if (b->getAlpha(1)==b && b!=b_bout1)
	{b_bout2=b; b=NULL;}
      else
	b=(brin *) fbrin.suivant(b);
    }
  
  // On prend les deux sommets en bout de chaine.
  s_bout1=b_bout1->getSommet();
  s_bout2=b_bout2->getSommet();
  
  
  // s_bout1 doit se trouver au-dessus de s_bout2.
  if (s_bout1->gety() < s_bout2->gety())
    {
      sommet *s; brin *b;
      s=s_bout1; s_bout1=s_bout2; s_bout2=s;
      b=b_bout1; b_bout1=b_bout2; b_bout2=b; 
    }
  
  //  cout<<endl<<b_bout1<<"\t"<<b_bout2<<"\t"<<s_bout1<<"\t"<<s_bout2<<"\t"<<endl;
  
  // Si l'axe ne se trouve pas parallle  Y, on place les bouts sur l'axe.
  if(s_bout1->getx() !=0 || s_bout1->gety() !=0 || s_bout2->getx() !=0 || s_bout2->gety() !=0)
    { 
      s_bout2->setx(0); s_bout2->setz(0); 
      s_bout1->setx(0); s_bout1->setz(0); 
    }
  
  // return brin_initial;
  
  sommet * s_b1 = new sommet(*s_bout1);
  sommet * s_b2 = new sommet(*s_bout2);
  

  // On prend tous les sommets du groupe d'aretes :
  b=b_bout2;
  brin * bb = b->getAlpha(0);
  fsommet.vide();
  fsommet.ajoute((sommet*) b->getSommet());
  while (bb != b_bout1)
    {
      b=bb->getAlpha(1);
      bb = b->getAlpha(0);       // On passe au suivant.
      // On ajoute le sommet courant  fsommet.
      fsommet.ajoute((sommet*) b->getSommet());
      
    }
  p=fsommet.taille();

 
  sommet * s1[p];
  sommet * s[p][m];
  coord y,r,alpha;
  


  // On met les sommets de fsommet dans le tableaux qui contiendra tous les sommets du volume:
  b=b_bout1;
  bb = b->getAlpha(0);
  sommet *ss;
  i=0;
  while (b != b_bout2)
    {
      ss=bb->getSommet();
      if (ss!=s_bout1 && ss!=s_bout2)
	{ s1[i]=ss; ++i; }
      b=bb->getAlpha(1);
      if (b != b_bout1)
	bb = b->getAlpha(0);       // On passe au suivant.
    }
  p=i;
  

  // On cre les nouveaux sommets en formant des cercles autour de l'axe :
  for (i=0; i<p; i++)
    {
      y = (s1[i])->gety();
      r = sqrt(
	       (sqr(s1[i]->getx())) +
	       (sqr(s1[i]->getz())));
      
      for (j=0; j<m; j++)
	{
	  alpha= 2*M_PI*(j-1)/m;
	  s[i][j]= new sommet(r*cos(alpha),y,r*sin(alpha));
	}
    }  
  
  supprimeComposante(b_bout1);

  // Cration des brins:
  brin * nord[m][2], * sud[m][2];
  brin * b[p][m][8];
  
  for (i=0; i<m; i++)
    for (j=0; j<2; j++)
      {
	nord[i][j]= ajouteBrin(s_b2);
	sud [i][j]= ajouteBrin(s_b1);
      }
  
  for (i=0; i<p; i++)
    for (j=0; j<m; j++)
      for (n=0; n<8; n++)
	// 8 brins par sommets... (ARG!)
	b[i][j][n]= ajouteBrin(s[i][j]);
  

  // Coutures:
  for (i=0; i<m; i++)
    {
      h= (i+m-1)%m;
      j= (i  +1)%m;
      
      sud [i][0]->setAlpha(0, b[ 0 ][i][6]); b[ 0 ][i][6]->setAlpha(0,sud [i][0]);
      sud [i][1]->setAlpha(0, b[ 0 ][i][5]); b[ 0 ][i][5]->setAlpha(0,sud [i][1]);
      nord[i][0]->setAlpha(0, b[p-1][i][1]); b[p-1][i][1]->setAlpha(0,nord[i][0]);
      nord[i][1]->setAlpha(0, b[p-1][i][2]); b[p-1][i][2]->setAlpha(0,nord[i][1]);
      
      sud [i][0]->setAlpha(1,sud [h][1]);
      sud [i][1]->setAlpha(1,sud [j][0]);
      nord[i][0]->setAlpha(1,nord[h][1]);
      nord[i][1]->setAlpha(1,nord[j][0]);
      
      sud [i][0]->setAlpha(2,sud [i][1]);
      sud [i][1]->setAlpha(2,sud [i][0]);
      nord[i][0]->setAlpha(2,nord[i][1]);
      nord[i][1]->setAlpha(2,nord[i][0]);
      
      for (v=0; v<p; v++)
	{
	  // Alpha 0:
	  b[v][i][0]->setAlpha(0,b[v][h][3]);
	  b[v][i][3]->setAlpha(0,b[v][j][0]);
	  b[v][i][4]->setAlpha(0,b[v][j][7]);
	  b[v][i][7]->setAlpha(0,b[v][h][4]);
	  
	  if (v!=0)
	    {
	      b[v][i][5]->setAlpha(0,b[v-1][i][2]);
	      b[v][i][6]->setAlpha(0,b[v-1][i][1]);
	    }
	  
	  if (v!=p-1)
	    {
	      b[v][i][1]->setAlpha(0,b[v+1][i][6]);
	      b[v][i][2]->setAlpha(0,b[v+1][i][5]);
	    }
	  // Alpha 1:
	  b[v][j][0]->setAlpha(1,b[v][j][1]);
	  b[v][j][1]->setAlpha(1,b[v][j][0]);
	  b[v][j][2]->setAlpha(1,b[v][j][3]);
	  b[v][j][3]->setAlpha(1,b[v][j][2]);
	  b[v][j][4]->setAlpha(1,b[v][j][5]);
	  b[v][j][5]->setAlpha(1,b[v][j][4]);
	  b[v][j][6]->setAlpha(1,b[v][j][7]);
	  b[v][j][7]->setAlpha(1,b[v][j][6]);
	  // Alpha 2:
	  b[v][j][0]->setAlpha(2,b[v][j][7]);
	  b[v][j][1]->setAlpha(2,b[v][j][2]);
	  b[v][j][2]->setAlpha(2,b[v][j][1]);
	  b[v][j][3]->setAlpha(2,b[v][j][4]);
	  b[v][j][4]->setAlpha(2,b[v][j][3]);
	  b[v][j][5]->setAlpha(2,b[v][j][6]);
	  b[v][j][6]->setAlpha(2,b[v][j][5]);
	  b[v][j][7]->setAlpha(2,b[v][j][0]);
	}
    }
  
  return b[p/2][0][1];
  
}


// Si on dsire extruder une face:
// ******************************
if (objet==4)
{      
  int nbs = fbrin.taille();     // nb de brins dj existants.
  
// On remplit l'ensemble fsommet avec les sommets de la face  extruder.
// --------------------------------------------------------------------
  b = (brin *) fbrin.premier();
  int sortir=0 , i=0;
// On parcourt les brins de la face.
  while (b != (brin *) fbrin.premier() || sortir == 0)
    {
	 // On ajoute le sommet courant  fsommet.
	 fsommet.ajoute((sommet*) b->getSommet());
	 
	 b = b->getAlpha(0);         // On prend le brin reli par alpha 0.      
	 b = b->getAlpha(1);         // On passe au suivant.
	 
	 sortir=1;      
	 
    }
  
  
// On calcule le vecteur normal  la face  extruder :
// -------------------------------------------------
//      sommet *v2 = v;
//      v = (sommet *) vecteurnormal(&fsommet, v2, brin_initial);
  
  
// Tableau qui contiendra tous les brins de l'ancienne face : 48 brins max par sommet.
  brin *tabf[fsommet.taille()+1][48*fsommet.taille()];
// Tableau qui contiendra tous les brins de la nouvelle face : 48 brins max par sommet.
  brin *tabn[fsommet.taille()+1][48*fsommet.taille()];
  
  
// On remplit le tableau tabf avec les brins de la face  extruder.
// ---------------------------------------------------------------
  b = (brin *) fbrin.premier();
  sortir=0; i=0;
  while (b != (brin *) fbrin.premier() || sortir == 0)    // On parcourt... 
    {                                          // ... les brins de la face.
	 tabf[i][0]=b;
	 
	 b = b->getAlpha(0);           // On prend le brin reli par alpha 0.            
	 tabf[i+1][1]=b;
	 b = b->getAlpha(1);           // On passe au suivant.
	 
	 sortir=1;
	 ++i;
    }
tabf[0][1]=tabf[0][0]->getAlpha(1);

// On parcourt les sommets de la face et on cre les nouveaux sommets.
// On en profite pour mettre les nouveaux brins dans nbrin.
sommet * s = (sommet*) fsommet.premier();
i=0;
while (s!=NULL)
{
  sommet * gerard = new sommet(*s + v);
  /*      sommet * gerard = new sommet(s->getx()+v->getx(),
		s->gety()+v->gety(),
		s->getz()+v->getz());*/
  
  b = ajouteBrin(gerard);      // On ajoute deux brins au nouveau sommet.
  bb = ajouteBrin(gerard);
  tabn[i][0] = bb;             // On ajoute les brins au tableau nbrin.
  tabn[i][1] = b;
  nbrin.ajoute(b);
  nbrin.ajoute(bb);
  
  s = (sommet*) fsommet.suivant(s);
  ++i;
}

// On parcourt les brins de la nouvelle face.
// Et on rcupre les nouveaux sommets dans nsommet.
b = (brin *) nbrin.premier();
while (b!=NULL)                       
{ 
  nsommet.ajoute((sommet*) b->getSommet());  
  b = (brin *) nbrin.suivant(b);
}


/* ************************************************************************
   On relie les brins du meme sommet par alpha 1 et les brins entre les
   sommets par alpha 0. Ainsi, on cre une nouvelle face, copie de la
   premire  une translation prs.
***********************************************************************/
b = (brin *) nbrin.premier();
bb = (brin *) nbrin.suivant(b);
while (bb!=NULL)
{
  if (b->getSommet() == bb->getSommet())  // Si les deux brins ...
    {                               // ... appartiennent au meme sommet :
	 b->setAlpha(1,bb);         //On les relie par Alpha 1
	 bb->setAlpha(1,b);
    } else {                     // Sinon, on les relie par Alpha 0.
	 b->setAlpha(0,bb);
	 bb->setAlpha(0,b);
    }
  
  bb = (brin *) nbrin.suivant(bb);       // On passe au brin suivant bb.
  if (bb != (brin *) nbrin.dernier())    // Si ce n'est pas le dernier brin de la liste :
    {
	 b = (brin *) nbrin.suivant(b);     // On passe b au brin suivant.
    }
  else                              // Si bb est le dernier de la liste :
    {
	 b = (brin *) nbrin.precedant(bb);
	 b->setAlpha(1,bb);
	 bb->setAlpha(1,b);
	 b = (brin *) nbrin.premier();
    }
}



/* ************************************************************************
   On parcourt les anciens et nouveaux sommets pour leur rajouter 4 brins
   que l'on rajoute dans les ensembles fbrin et nbrin.
***********************************************************************/
s = (sommet*) fsommet.premier();
sommet *ns = (sommet*) nsommet.premier();
//  while (s != NULL && ns != NULL)
for (i=0 ; i<nsommet.taille() ; i++)
{
  for (int j=2 ; j<6 ; j++)
    {
	 b =  ajouteBrin(s);
	 bb = ajouteBrin(ns);
	 tabf[i][j] = b;
	 tabn[i][j] = bb;
	 fbrin.ajoute(b);
	 nbrin.ajoute(bb);
	 
    }
  s  = (sommet*) fsommet.suivant(s) ;
  ns = (sommet*) nsommet.suivant(ns) ;
}

for (int i=0 ; i <nsommet.taille() ; i++)
{
  // coutures par Alpha 2 :
  // --------------------
  tabf[i][0]->setAlpha(2,tabf[i][3]);
  tabf[i][3]->setAlpha(2,tabf[i][0]);
  tabn[i][0]->setAlpha(2,tabn[i][3]);
  tabn[i][3]->setAlpha(2,tabn[i][0]);
  
  tabf[i][1]->setAlpha(2,tabf[i][2]);
  tabf[i][2]->setAlpha(2,tabf[i][1]);
  tabn[i][1]->setAlpha(2,tabn[i][2]);
  tabn[i][2]->setAlpha(2,tabn[i][1]);
  
  tabf[i][4]->setAlpha(2,tabf[i][5]);
  tabf[i][5]->setAlpha(2,tabf[i][4]);
  tabn[i][4]->setAlpha(2,tabn[i][5]);
  tabn[i][5]->setAlpha(2,tabn[i][4]);
  
  
  // coutures par Alpha 1 :
  // --------------------
  tabf[i][3]->setAlpha(1,tabf[i][4]);
  tabf[i][4]->setAlpha(1,tabf[i][3]);
  tabn[i][3]->setAlpha(1,tabn[i][4]);
  tabn[i][4]->setAlpha(1,tabn[i][3]);
  
  tabf[i][2]->setAlpha(1,tabf[i][5]);
  tabf[i][5]->setAlpha(1,tabf[i][2]);
  tabn[i][2]->setAlpha(1,tabn[i][5]);
  tabn[i][5]->setAlpha(1,tabn[i][2]);
  
  
  // coutures par Alpha 0 :
  // --------------------      
  if (i==nsommet.taille()-1)
    { 
	 tabf[i][3]->setAlpha(0,tabf[0][2]);
	 tabf[0][2]->setAlpha(0,tabf[i][3]);
	 tabn[i][3]->setAlpha(0,tabn[0][2]);
	 tabn[0][2]->setAlpha(0,tabn[i][3]);
    } else {
	 tabn[i][3]->setAlpha(0,tabn[i+1][2]);
	 tabn[i+1][2]->setAlpha(0,tabn[i][3]);
	 tabf[i][3]->setAlpha(0,tabf[i+1][2]);
	 tabf[i+1][2]->setAlpha(0,tabf[i][3]);
    }
  
  tabf[i][4]->setAlpha(0,tabn[i][4]);     // On relie les deux faces.
  tabn[i][4]->setAlpha(0,tabf[i][4]);
  tabf[i][5]->setAlpha(0,tabn[i][5]);
  tabn[i][5]->setAlpha(0,tabf[i][5]);
  
}      


// On renvoie le brin image du brin initial :
for (int i=0 ; i <nsommet.taille() ; i++)
  for (int j=0 ; j <nbrin.taille()/nsommet.taille() ; j++)
{
  if (brin_initial == tabf[i][j])
    return  tabn[i][j];
}

}


// Si on dsire extruder un volume :
// *******************************
if (objet==5)
{
  int nbs = fbrin.taille();     // nb de brins dj existants.
  
  
// On remplit l'ensemble fsommet avec les sommets de la face  extruder.
// --------------------------------------------------------------------
  b = (brin *) fbrin.premier();
  int sortir=0 , i=0;
// On parcourt les brins de la face.
  while (b != (brin *) fbrin.premier() || sortir == 0)
    {
	 // On ajoute le sommet courant  fsommet.
	 fsommet.ajoute((sommet*) b->getSommet());
	 
	 b = b->getAlpha(0);         // On prend le sommet reli par alpha 0.      
	 b = b->getAlpha(1);         // On passe au suivant.
	 
	 sortir=1;      
	 
    }
  
// Tableau qui contiendra tous les brins de l'ancienne face : 48 brins max par sommet.
  brin *tabf[fsommet.taille()+1][48*fsommet.taille()];
// Tableau qui contiendra tous les brins de la nouvelle face : 48 brins max par sommet.
  brin *tabn[fsommet.taille()+1][48*fsommet.taille()];
  
  
// On remplit le tableau tabf avec les brins de la face  extruder.
// ---------------------------------------------------------------
  b = (brin *) fbrin.premier();
  sortir=0; i=0;
  while (b != (brin *) fbrin.premier() || sortir == 0)    // On parcourt... 
    {                                          // ... les brins de la face.
	 tabf[i][0]=b;
	 
	 b = b->getAlpha(0);           // On prend le sommet reli par alpha 0.            
	 tabf[i+1][1]=b;
	 b = b->getAlpha(1);           // On passe au suivant.
	 
	 sortir=1;
	 ++i;
    }
tabf[0][1]=tabf[0][0]->getAlpha(1);


// On parcourt les sommets de la face et on cre les nouveaux sommets.
// On en profite pour mettre les nouveaux brins dans nbrin.
// la diffrence avec avant c'est que la nouvelle face se trouve exactement sur l'ancienne.
sommet * s = (sommet*) fsommet.premier();
i=0;
while (s!=NULL)
{
  sommet * gerard = new sommet(*s);
  
  b = ajouteBrin(gerard);      // On ajoute deux brins au nouveau sommet.
  bb = ajouteBrin(gerard);
  tabn[i][0] = bb;             // On ajoute les brins au tableau nbrin.
  tabn[i][1] = b;
  nbrin.ajoute(b);
  nbrin.ajoute(bb);
  
  s = (sommet*) fsommet.suivant(s);
  ++i;
}

// On parcourt les brins de la nouvelle face.
// Et on rcupre les nouveaux sommets dans nsommet.
b = (brin *) nbrin.premier();
while (b!=NULL)                       
{ 
  nsommet.ajoute((sommet*) b->getSommet());  
  b = (brin *) nbrin.suivant(b);
}


/* ************************************************************************
   On relie les brins du meme sommet par alpha 1 et les brins entre les
   sommets par alpha 0. Ainsi, on cre une nouvelle face, copie de la
   seconde  la meme place.
***********************************************************************/
b = (brin *) nbrin.premier();
bb = (brin *) nbrin.suivant(b);
while (bb!=NULL)
{
  if (b->getSommet() == bb->getSommet())  // Si les deux brins ...
    {                               // ... appartiennent au meme sommet :
	 b->setAlpha(1,bb);         //On les relie par Alpha 1
	 bb->setAlpha(1,b);
    } else {                     // Sinon, on les relie par Alpha 0.
	 b->setAlpha(0,bb);
	 bb->setAlpha(0,b);
    }
  
  bb = (brin *) nbrin.suivant(bb);       // On passe au brin suivant bb.
  if (bb != (brin *) nbrin.dernier())    // Si ce n'est pas le dernier brin de la liste :
    {
	 b = (brin *) nbrin.suivant(b);     // On passe b au brin suivant.
    }
  else                              // Si bb est le dernier de la liste :
    {
	 b = (brin *) nbrin.precedant(bb);
	 b->setAlpha(1,bb);
	 bb->setAlpha(1,b);
	 b = (brin *) nbrin.premier();
    }
}

b  = tabf[0][0];
bb = tabn[0][0];

brin * nb = extrusionFace(bb, v);
coudre(b,bb);

return  nb;


}

}
