/* fichier extrusion_multiple.cc
   ralise l'extrusion d'une face selon un chemin
*/

void base(const brin * b, sommet & v, sommet & n, sommet & a)
{
  sommet s0,s1,s2;

  s1 = * b->getSommet();
  s2 = * b->getAlpha(0)->getSommet();

  v= s2-s1;

  if (b->getAlpha(1)==b)
    s0 = * b->getAlpha(0)->getAlpha(1)->getAlpha(0)->getSommet();
  else
    s0 = * b->getAlpha(1)->getAlpha(0)->getSommet();

  sommet v1,v2;
  coord  n1,n2;

  v1= s1-s0; n1= v1.norme(); if (nul(n1)) v1=sommet(0,0,1); else v1/=n1;
  v2= s2-s1; n2= v2.norme(); if (nul(n2)) v2=sommet(0,0,1); else v2/=n2;

  if (b->getAlpha(1)==b)
    n= v2;
  else
    n= v1+v2;

  a= v2-v1;
}

bool gcarte::extrusionMultiplePossible (const brin * bFace, const brin * bChem) const
  // vrifie que les spcifications sont vrifies:
  // * le brin bFace appartient  une face indpendante
  // * le brin bChem est bien sur un cycle (ou au DEBUT d'un chemin) indpendant.
{
  return
    bFace!=NULL && bChem!=NULL &&
    !orbiteFace(bFace).contient(bChem) &&
    (faceFermee(bChem) || (bChem->getAlpha(0)!=bChem && bChem->getAlpha(1)==bChem)) &&
    faceFermee(bFace) &&
    orbiteVolume(bFace).taille() == orbiteFace(bFace).taille() &&
    orbiteVolume(bChem).taille() == orbiteFace(bChem).taille();
}

brin * gcarte::extrusionMultiple(brin * bFace, const brin * bChem)
  // bFace sert  reprer la face,
  // bChem est le 1er brin du chemin  suivre
{
  if (!extrusionMultiplePossible(bFace,bChem))
    return bFace;

  ensemble ES;
  sommet   v, n1,d1,n2,d2;

  ES= sommets(orbiteFace(bFace));

  // Position de dpart de la face:
  translation(*bChem->getSommet() - barycentre(ES), ES);

  n1= normale(bFace);
  d1= * bFace->getSommet() - barycentre(ES);
  // Orientation de la face de dpart:
  base(bChem,v,n2,d2);
  orientation(n1,d1,n2,d2, ES);
  n1=n2;
  d1=d2;
  // Extrusions:
  const brin * bc= bChem;
  brin * bf= bFace;
  do
    {
	 bf= extrusionFace(bf,v);
      bc= bc->getAlpha(0)->getAlpha(1);

	 base(bc,v,n2,d2);

	 orientation(n1,d1,n2,d2, sommets(orbiteFace(bf)));
	 n1= n2;
	 d1= d2;
    }
  while ((bc->getAlpha(1)!=bc) && (bc!=bChem));

  if (bc==bChem /* face ferme */)
    coudre(bf,bFace);

  return bFace;
}
