#ifndef _fenetre_h
#define _fenetre_h

#include <qobject.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qintdict.h>

#include "ensemble.h"
#include "gcarte.h"
#include "fenetreGL.h"

typedef enum
{
  Creation,Couture,
  RotationScene,
  TailleObjet,RotationObjet,PositionObjet,
  AdjonctionSommet, AdjonctionArete, AdjonctionFace, ExtrusionMultiple
}
mode;

typedef enum
{
  Sommet,Arete,Face,Volume,Composante,Tout
}
modeObjet;

class fenetre: public fenetreGL
{
  Q_OBJECT

 private:
  enum         mode      modeActif;
  enum         modeObjet sousMode ;
  bool         cg, cgo,cgt,cgp;
  int          memoX,memoY;        // position de la souris lors d'un clic.
  bool         moved;              // pour savoir si la souris a t dplace
  int          memoDX,memoDY;      // distance au sommet point. (pour les dplacements, rotations d'objets,...)
  sommet       sclic;              // sommet slectionn (un sommet du brin)
  int          deltaX,deltaY;      // sommet slectionn  l'cran par rapport  la souris
  float        memoAlpha,memoBeta;
  coord        memoK;
  int          B1,B2,B3;           // tat des boutons lors d'un clic.
  bool         cx,cy,cz;           // Composantes x y et z (pour dplacements, rotations...)
  unsigned int clicMode;           // pour les coutures, les dplacements, rotations...
  ensemble     ES,memoES;          // liste des sommets pour dplacement, rotation...
  sommet       bary;               // barycentre (pour les rotations et les agrandissements...)

  bool         antiAlias;
  bool         work;

  ensemble     EB;                 // liste de brins (pour l'adjonction d'arte)

  bool     alpha21,alpha22;        // Pour changer de brin en cliquant plusieurs fois sur le meme (on change soit par alpha2 soit par alpha3, un tout chacun)

  brin * itere(brin *, bool &);

  void essaiSelection1(brin *);
  void essaiSelection2(brin *);

  sommet sommetClique(int,int);
  void beginClic();
  void endClic();

 protected:
  void mousePressEvent  (QMouseEvent  *);
  void mouseReleaseEvent(QMouseEvent  *);
  void mouseMoveEvent   (QMouseEvent  *);

  void enterEvent       (QEvent       *);
  void leaveEvent       (QEvent       *);

 signals:
  void boutons(fenetre *,bool,bool,bool);

 public:
  fenetre(QWidget * =0);
  ~fenetre();

  void changeFace ();
  void changeArete();

  enum mode getMode(); 
  void setMode(enum mode);
  enum modeObjet getSousMode();
  void setSousMode(enum modeObjet);

  bool getx() const;
  bool gety() const;
  bool getz() const;
  void setx(const bool);
  void sety(const bool);
  void setz(const bool);
  bool geto() const;
  bool getp() const;
  bool gett() const;
  void seto(const bool);
  void setp(const bool);
  void sett(const bool);

  bool couturesGeometriques();
  void setCouturesGeometriques(bool);

  bool getAntiAlias();
  void setAntiAlias(bool);

  bool working(); // Pour viter les changements de mode pendant une opration.
};

#endif
