#ifndef _fenetre3D_h
#define _fenetre3D_h

#include <qobject.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qintdict.h>

#include "ensemble.h"
#include "gcarte.h"

typedef enum
{
  Creation,Couture,
  ZoomScene,RotationScene,
  TailleObjet,RotationObjet,PositionObjet
}
mode;

class fenetre3D: public QWidget
{
  Q_OBJECT

 private:
  // tableaux de sinus et de cosinus:
  // (QT refuse SIN[360] ainsi que les variables statiques)
  coord * SIN, * COS;
  
  coord
    yoeil, // distance de l'oeil  l'origine
    yplan, // distance du plan de projection  l'origine
    kmul ; // coefficient mutiplicateur (pour les zooms)
  
  int
    alpha, // angle de vue horizontal
    beta ; // angle de vue vertical
  
  enum   mode modeActif;
  int    memoX,memoY;        // position de la souris lors d'un clic.
  bool   alpha2;             // Pour changer de brin en cliquant plusieurs fois sur le meme (on change soit par alpha2 soit par alpha3, un tout chacun)
  brin * bbase;              // Brin de base (utilis avec alpha2...)
  coord  memoK;
  int    epaisseur;          // Taille de Iterateur(sbrin,false,false,true,true)
  int    memoAlpha,memoBeta;
  bool   B1,B2,B3;           // tat des boutons lors d'un clic.

  int update,attenteMAJ;
  QPixmap * buffer ; // Affichage en double buffering pour viter que a flashe...
  bool etapesOn,bufferOn;

  brin     * sbrin;
  ensemble * sreste, * sface, * svolume, * scomposante;

  gcarte * G;

  // Fonction  de calcul de la position d'un sommet aprs rotations selon alpha et beta:
  sommet * rotation(sommet *);
  // Fonctions de calcul des coordonnes d'un sommet projet  l'cran:
  int xp(sommet *);
  int yp(sommet *);
  // Fonction qui calcule le plongement  l'cran de tous les sommets du graphe:
  QIntDict<QPoint> * plongement();
  // Fonction auxiliaire de brinProche qui calcule la distance au carr d'un point  un segment:
  int distance(int,int,int,int,int,int);
  // Fonction renvoyant le brin dont le plongement SUR L'ECRAN est le plus proche du point cliqu:
  // (renvoie ventuellement NULL)
  brin * brinProche(int,int);

  void majBuffer();
  sommet * positionBrin(int,int);
  // Fonctions de dessin:
  void dessineQuadrillage(QPainter *);
  void dessineNormale    (QPainter *,char *,sommet *,int,int,int,int);
  void dessineEnsemble   (QPainter *,ensemble *, QColor, QIntDict<QPoint> *);
  void dessineGraphe     (QPainter *);
  void dessineInfos      (QPainter *);
  // Fonction auxiliaire de setSelection:
  ensemble * supprimeDoublons(ensemble *);

 private slots:
  void carteModifiee(gcarte *);

 protected:
  void resizeEvent      (QResizeEvent *);
  void paintEvent       (QPaintEvent  *);
  void mousePressEvent  (QMouseEvent  *);
  void mouseReleaseEvent(QMouseEvent  *);
  void mouseMoveEvent   (QMouseEvent  *);

  void maj(); // mise--jour: appelle repaint SSI update=0.

 public:
  fenetre3D(QWidget * =0);
  ~fenetre3D();

  brin * ajouteBrin(sommet *);

  brin * getSelection();
  void setSelection(brin *);

  int getAlpha(); void setAlpha(int);
  int getBeta (); void setBeta (int);
  int getK    (); void setK    (int);

  enum mode getMode(); void setMode(enum mode);

  bool doubleBuffer();
  void setDoubleBuffer(bool);
  bool etapes();
  void setEtapes(bool);

  void beginUpdate();
  void endUpdate();

  gcarte * carte();
};

#endif
