#ifndef _fenetreGL_h
#define _fenetreGL_h

#include <qobject.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qlist.h>
#include <qintdict.h>

#include "ensemble.h"
#include "superCarte.h"

#include <qgl.h>

typedef struct { float x,y,z; } Vector3;
typedef float Vector4[4];

typedef struct { Vector3 Pos;float xR,yR,zR; } _View;


class fenetreGL: public QGLWidget
{
  Q_OBJECT

 private:
  bool Shade;
  bool Blend;
  bool Eclate;
  bool Lighting;
  bool Antialias;
  float rayon;								// rayon de camera
  float alpha,beta;
  float kmul;
  float ViewWidth;							// Local Width of the viewport. the height is calculated
  											// to keep dimension rate
  int ViewportHeight, ViewportWidth;		// In screen coordinates...

  QList<QColor> * couleurs;


//  int update,attenteMAJ;

  superCarte * G;

  // Fonction auxiliaire de brinProche qui calcule la distance au carr d'un point  un segment:
  int distance(int,int,int,int,int,int);

  // Fonctions de dessin:
  void dessineQuadrillage();
  void dessineNormale    (char *,sommet *,int,int,int,int);
  void dessineEnsemble   (ensemble *, ensemble *, QColor);//, QIntDict<QPoint> *);
  void dessineGraphe     ();
  void dessineInfos      ();
  void dessinePlein		 ();
  void dessineEclate	 ();

  sommet *normaleVertex(brin*);
  sommet *normaleFace(brin*);

 private slots:
  void carteModifiee(superCarte *);

 signals :
  void raffraichissement(fenetreGL*);

 protected:
//  void resizeEvent      (QResizeEvent *);
//  void paintEvent       (QPaintEvent  *);

  void initializeGL();							// ...
  void paintGL();								// paint event
  void resizeGL(int,int);						// update ViewportHeight and width

  void maj(); // mise--jour: appelle repaint SSI update=0.
  void majBuffer();			// affiche un peu tout...

 public:
  fenetreGL(QWidget *parent);
//  int id,QWidget *parent,
//						const char * name=0,const QGLWidget * shareWidget = 0);
  ~fenetreGL();

  superCarte * carte();

  // Renvoie un sommet tel que z=0 correspondant au point cliqu  l'cran:
  // (renvoie ventuellement NULL si le point est loin de l'origine)
//  sommet * positionEcran(int,int);
  sommet * positionEcranXY(int,int,coord,bool =true);
  sommet * positionEcranYZ(int,int,coord,bool =true);
  sommet * positionEcranXZ(int,int,coord,bool =true);
  sommet *positionEcranZ(int,int,coord,coord);


  // Fonction renvoyant le brin dont le plongement SUR L'ECRAN est le plus proche du point cliqu:
  // (renvoie ventuellement NULL)
//	int fenetreGL::distance(int x,int y,int x1, int y1, int x2, int y2);
  ensemble brinsProches(int,int);
  QPoint projection(sommet);	


  float getAlpha(); void setAlpha(float);
  float getBeta (); void setBeta (float);
  float getK    (); void setK    (float);
  void getPos(float *,float *,float *);
  void setPos(float,float,float);

  void setAlphaBeta(float,float);

  void setShade(bool);bool getShade();
  void setBlend(bool);bool getBlend();
  void setEclate(bool);bool getEclate();
  void setLighting(bool);bool getLighting();

  void DisplayWithAntialias(bool);
//

/*  void beginUpdate();
  void endUpdate();*/
};

#endif
