#include <qapplication.h>
#include <qfiledialog.h>
#include <qfileinfo.h>
#include <qkeycode.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qpixmap.h>

#include "base.h"
#include "aPropos.h"
#include "dialogXYZ.h"
#include "dialogue.h"
#include "modeleur.h"
#include "couleurs.h"

#include "_nouveau.xpm"
#include "_charger.xpm"
#include "_sauver.xpm"
#include "_quitter.xpm"

#include "brin0.xpm"
#include "brin1.xpm"
#include "brin_.xpm"
#include "couture0.xpm"
#include "couture1.xpm"
#include "couture_.xpm"
#include "rotScene0.xpm"
#include "rotScene1.xpm"
#include "rotScene_.xpm"
#include "posObjet0.xpm"
#include "posObjet1.xpm"
#include "posObjet_.xpm"
#include "rotObjet0.xpm"
#include "rotObjet1.xpm"
#include "rotObjet_.xpm"
#include "taiObjet0.xpm"
#include "taiObjet1.xpm"
#include "taiObjet_.xpm"

#include "sommet0.xpm"
#include "sommet1.xpm"
#include "sommet_.xpm"
#include "arete0.xpm"
#include "arete1.xpm"
#include "arete_.xpm"
#include "face0.xpm"
#include "face1.xpm"
#include "face_.xpm"

#include "objFace0.xpm"
#include "objFace1.xpm"
#include "objFace_.xpm"
#include "objPyramide0.xpm"
#include "objPyramide1.xpm"
#include "objPyramide_.xpm"
#include "objCube0.xpm"
#include "objCube1.xpm"
#include "objCube_.xpm"
#include "objSphere0.xpm"
#include "objSphere1.xpm"
#include "objSphere_.xpm"
#include "objTore0.xpm"
#include "objTore1.xpm"
#include "objTore_.xpm"

#include "paramFace.xpm"
#include "paramPyram.xpm"
#include "paramSphereM.xpm"
#include "paramSphereP.xpm"
#include "paramToreM.xpm"
#include "paramToreP.xpm"

#include "suppression0.xpm"
#include "suppression1.xpm"
#include "suppression_.xpm"
#include "duplication0.xpm"
#include "duplication1.xpm"
#include "duplication_.xpm"
#include "decouture0.xpm"
#include "decouture1.xpm"
#include "decouture_.xpm"
#include "extrusion0.xpm"
#include "extrusion1.xpm"
#include "extrusion_.xpm"
#include "extrusionChemin0.xpm"
#include "extrusionChemin1.xpm"
#include "extrusionChemin_.xpm"
#include "fusion0.xpm"
#include "fusion1.xpm"
#include "fusion_.xpm"
#include "option0.xpm"
#include "option1.xpm"

#include "s0.xpm"
#include "s1.xpm"
#include "a0.xpm"
#include "a1.xpm"
#include "f0.xpm"
#include "f1.xpm"
#include "v0.xpm"
#include "v1.xpm"
#include "c0.xpm"
#include "c1.xpm"
#include "t0.xpm"
#include "t1.xpm"

#include "cg0.xpm"
#include "cg1.xpm"
#include "ct0.xpm"
#include "ct1.xpm"

#include "cgo0.xpm"
#include "cgo1.xpm"
#include "cgp0.xpm"
#include "cgp1.xpm"
#include "cgt0.xpm"
#include "cgt1.xpm"

#include "x0.xpm"
#include "x1.xpm"
#include "y0.xpm"
#include "y1.xpm"
#include "z0.xpm"
#include "z1.xpm"

#include "x3gc.xpm"

#define Ti  (48) // taille des icones
#define Hm  (30) // hauteur de la barre des menus; ne pas modifier cette valeur...
#define He  (48) // hauteur de la barre d'tat
#define Hi  (31) // hauteur de la barre d'infos
#define Hs  (15) // Espace de sparation (entre certaines icones seulement)
#define Wd (171) // Longueur des boites de dialogue

#define TMINFENETRE (10*Ti + 5*Ti/3 + 4*Hs)

#define FILTRE ("Fichiers x3gc (*.3gc)")
//-----------------------------------------------------------------------------
// Constructeur:
//-----------------------------------------------------------------------------
modeleur::modeleur()
{
  //...........................................................................
  // Allocation des objets:
  f           = new fenetre   (this);
  be          = new barreEtat (this);
  bi          = new barreInfos(this);
  mb          = new QMenuBar  (this);
  
  barreModes  = new QWidget(this);
  barreActions= new QWidget(this);
  barreParams = new QWidget(this);
  
  graphe      = new QPopupMenu;
  mode        = new QPopupMenu;
  sousMode    = new QPopupMenu;
  objets      = new QPopupMenu;
  actions     = new QPopupMenu;
  invo        = new QPopupMenu;
  options     = new QPopupMenu;
  infos       = new QPopupMenu;

  dFace       = new dialogue(barreParams,"Face"    ,
					    "ARETES"    ,3,16,4, paramFace_xpm    );
  dPyram      = new dialogue(barreParams,"Pyramide",
					    "BASE"      ,3,16,4, paramPyram_xpm   );
  dSphere     = new dialogue(barreParams,"Sphre"  ,
					    "MERIDIENS" ,3,16,7, paramSphereM_xpm ,
					    "PARALLELES",1,16,4, paramSphereP_xpm );
  dTore       = new dialogue(barreParams,"Tore"    ,
					    "MERIDIENS" ,3,12,7, paramToreM_xpm   ,
					    "PARALLELES",3,12,4, paramToreP_xpm   ,
					    true);
  
  x3gc        = new QPixmap(x3gc_xpm);
  //...........................................................................
  // Cration des menus:
  graphe  ->insertItem(QPixmap(_nouveau_xpm        ),"&Nouveau"              ,this,SLOT(menuNouveau      ()),     Key_F1        );
  graphe  ->insertSeparator();                                                                                               
  graphe  ->insertItem(QPixmap(_sauver_xpm         ),"&Enregistrer"          ,this,SLOT(menuSauver       ()),     Key_F2        );
  graphe  ->insertItem(                              "Enregistrer &Sous..."  ,this,SLOT(menuSauverSous   ()),ALT +Key_F2        );
  graphe  ->insertSeparator();
  graphe  ->insertItem(QPixmap(_charger_xpm        ),"&Ouvrir..."            ,this,SLOT(menuCharger      ()),     Key_F3        );
  graphe  ->insertItem(                              "&Insrer..."           ,this,SLOT(menuInserer      ()),ALT +Key_F3        );
  graphe  ->insertSeparator();                                                                                               
  graphe  ->insertItem(QPixmap(_quitter_xpm        ),"&Quitter x3gc"         ,this,SLOT(menuQuitter      ()),ALT +Key_X         );
  
  mode    ->insertItem(QPixmap(brin__xpm           ),"Cration &Brin"        ,this,SLOT(menuBrin         ()),     Key_B      , 0);
  mode    ->insertItem(QPixmap(couture__xpm        ),"Slection/&Couture"    ,this,SLOT(menuCouture      ()),     Key_C      , 1);
  mode    ->insertSeparator();                                                                                               
  mode    ->insertItem(QPixmap(rotScene__xpm       ),"Point de &Vue"         ,this,SLOT(menuAngleVue     ()),     Key_V      , 2);
  mode    ->insertSeparator();                                                                                               
  mode    ->insertItem(QPixmap(posObjet__xpm       ),"&Position Objet"       ,this,SLOT(menuPos          ()),     Key_P      , 3);
  mode    ->insertItem(QPixmap(rotObjet__xpm       ),"&Rotation Objet"       ,this,SLOT(menuRot          ()),     Key_R      , 4);
  mode    ->insertItem(QPixmap(taiObjet__xpm       ),"&Taille Objet"         ,this,SLOT(menuTai          ()),     Key_T      , 5);
  mode    ->insertSeparator();                                                                                               
  mode    ->insertItem(QPixmap(sommet__xpm         ),"Adjonction &Sommet"    ,this,SLOT(menuNouvSommet   ()),     Key_S      , 6);
  mode    ->insertItem(QPixmap(arete__xpm          ),"Adjonction &Arte"     ,this,SLOT(menuNouvArete    ()),     Key_A      , 7);
  mode    ->insertItem(QPixmap(face__xpm           ),"Adjonction &Face"      ,this,SLOT(menuNouvFace     ()),     Key_F      , 8);
  mode    ->insertSeparator();                                                                                               
  mode    ->insertItem(QPixmap(extrusionChemin__xpm),"Extrusion &Multiple"   ,this,SLOT(menuExtrusionM   ()),     Key_M      , 9);
  
  sousMode->insertItem(QPixmap(ct0_xpm             ),"Coutures &Topologiques",this,SLOT(menuTopo         ()),     Key_F4     , 0);
  sousMode->insertItem(QPixmap(cg0_xpm             ),"Coutures &Gomtriques",this,SLOT(menuGeo          ()),     Key_F5     , 1);
  sousMode->insertSeparator();                                                                                               
  sousMode->insertItem(QPixmap(cgo0_xpm            ),"/ &Orientation"        ,this,SLOT(menuCGOri        ()),     Key_F6     , 2);
  sousMode->insertItem(QPixmap(cgt0_xpm            ),"/ Tai&lle"             ,this,SLOT(menuCGTai        ()),     Key_F7     , 3);
  sousMode->insertItem(QPixmap(cgp0_xpm            ),"/ &Position"           ,this,SLOT(menuCGPos        ()),     Key_F8     , 4);
  sousMode->insertSeparator();                                                                                               
  sousMode->insertItem(QPixmap(s0_xpm              ),"&Sommet"               ,this,SLOT(menuSommet       ()),ALT +Key_S      , 5);
  sousMode->insertItem(QPixmap(a0_xpm              ),"&Arte"                ,this,SLOT(menuArete        ()),ALT +Key_A      , 6);
  sousMode->insertItem(QPixmap(f0_xpm              ),"&Face"                 ,this,SLOT(menuFace         ()),ALT +Key_F      , 7);
  sousMode->insertItem(QPixmap(v0_xpm              ),"&Volume"               ,this,SLOT(menuVolume       ()),ALT +Key_V      , 8);
  sousMode->insertItem(QPixmap(c0_xpm              ),"&Composante"           ,this,SLOT(menuComposante   ()),ALT +Key_C      , 9);
  sousMode->insertItem(QPixmap(t0_xpm              ),"To&ut"                 ,this,SLOT(menuTout         ()),ALT +Key_T      ,10);
  sousMode->insertSeparator();                                                                                               
  sousMode->insertItem(QPixmap(x0_xpm              ),"Composante &X"         ,this,SLOT(menuX            ()),     Key_X      ,11);
  sousMode->insertItem(QPixmap(y0_xpm              ),"Composante &Y"         ,this,SLOT(menuY            ()),     Key_Y      ,12);
  sousMode->insertItem(QPixmap(z0_xpm              ),"Composante &Z"         ,this,SLOT(menuZ            ()),     Key_Z      ,13);
  
  objets  ->insertItem(QPixmap(objFace__xpm        ),"Nouvelle &Face"        ,this,SLOT(menuOFace        ()),CTRL+Key_F         );
  objets  ->insertItem(QPixmap(objPyramide__xpm    ),"Nouvelle &Pyramide"    ,this,SLOT(menuOPyram       ()),CTRL+Key_P         );
  objets  ->insertItem(QPixmap(objCube__xpm        ),"Nouveau &Cube"         ,this,SLOT(menuOCube        ()),CTRL+Key_C         );
  objets  ->insertItem(QPixmap(objSphere__xpm      ),"Nouvelle &Sphre"      ,this,SLOT(menuOSphere      ()),CTRL+Key_S         );
  objets  ->insertItem(QPixmap(objTore__xpm        ),"Nouveau &Tore"         ,this,SLOT(menuOTore        ()),CTRL+Key_T         );
  
  actions ->insertItem(QPixmap(duplication__xpm    ),"Du&pliquer Objet"      ,this,SLOT(menuDupliquer    ()),     Key_Return    );
  actions ->insertItem(QPixmap(suppression__xpm    ),"&Supprimer Objet"      ,this,SLOT(menuSupprimer    ()),     Key_Delete    );
  actions ->insertSeparator();                                                                                               
  actions ->insertItem(QPixmap(decouture__xpm      ),"&Dcoudre"             ,this,SLOT(menuDecoudre     ()),     Key_D         );
  actions ->insertItem(QPixmap(fusion__xpm         ),"&Fusionner Volumes"    ,this,SLOT(menuFusionner    ()),     Key_Plus      );
  actions ->insertSeparator();                                                                                               
  actions ->insertItem(QPixmap(extrusion__xpm      ),"&Extruder Face"        ,this,SLOT(menuExtruder     ()),     Key_E         );
  actions ->insertSeparator();                                                                                               
  actions ->insertItem(                              "Changer de &Face"      ,this,SLOT(menuChangerFace  ()),     Key_PageUp    );
  actions ->insertItem(                              "Changer d'&Arte"      ,this,SLOT(menuChangerArete ()),     Key_PageDown  );
  actions ->insertSeparator();
  actions ->insertItem(                              "&Orientabilit"        ,this,SLOT(menuOrientabilite()),     Key_O         );
  
  invo    ->insertItem(                              "Alpha &0"              ,this,SLOT(menuAlpha0      ()),     Key_0          );
  invo    ->insertItem(                              "Alpha &1"              ,this,SLOT(menuAlpha1      ()),     Key_1          );
  invo    ->insertItem(                              "Alpha &2"              ,this,SLOT(menuAlpha2      ()),     Key_2          );
  invo    ->insertItem(                              "Alpha &3"              ,this,SLOT(menuAlpha3      ()),     Key_3          );
  
  options ->insertItem(                              "Vue &Eclate"          ,this,SLOT(menuEclatee     ()),ALT+ Key_E       , 0);
  options ->insertSeparator();
  options ->insertItem(                              "&Faces"                ,this,SLOT(menuFacettes    ()),     Key_F9      , 1);
  options ->insertItem(                              "&Transparence"         ,this,SLOT(menuTransparence()),     Key_F10     , 2);
  options ->insertItem(                              "Ec&lairage"            ,this,SLOT(menuLighting    ()),     Key_F11     , 3);
  options ->insertSeparator();
  options ->insertItem(                              "&Antialias"            ,this,SLOT(menuAntiAlias   ()),     Key_F12     , 4);

  infos   ->insertItem(                              "A Propos de &Qt"       ,this,SLOT(menuQt          ()),     Key_Q          );
  infos   ->insertItem(                              "A &Propos de x3gc"     ,this,SLOT(menuAPropos     ()),     Key_Escape     );
  
  mb->insertItem("&Graphe"     ,graphe  );
  mb->insertItem("&Mode"       ,mode    );
  mb->insertItem("&Sous Mode"  ,sousMode);
  mb->insertItem("&Objets"     ,objets  );
  mb->insertItem("&Actions"    ,actions );
  mb->insertItem("&Involutions",invo    );
  mb->insertItem("&Rendu"      ,options );
  mb->insertSeparator();
  mb->insertItem("&?"          ,infos   );
  //...........................................................................
  // Cration des boutons:
  __dy=0;
  ajouteBoutonMode  (bCreation    ,               false, brin1_xpm           , brin0_xpm           ,"B"    ,"Cration Brin"          );
  ajouteBoutonMode  (bCouture     ,               false, couture1_xpm        , couture0_xpm        ,"C"    ,"Slection/Couture Brins");
  ajouteMiniBouton  (bTopo        ,  Ti/6, false, false, ct1_xpm             , ct0_xpm             ,"F8"   ,"Coutures Topologiques"  );
  ajouteMiniBouton  (bGeo         ,  Ti/2, true , false, cg1_xpm             , cg0_xpm             ,"F9"   ,"Coutures Gomtriques"  );
  ajouteMiniBouton  (bgo          ,     0, false, false, cgo1_xpm            , cgo0_xpm            ,"F10"  ,"/ Orientation"          );
  ajouteMiniBouton  (bgt          ,  Ti/3, false, false, cgt1_xpm            , cgt0_xpm            ,"F11"  ,"/ Taille"               );
  ajouteMiniBouton  (bgp          ,2*Ti/3, true , true , cgp1_xpm            , cgp0_xpm            ,"F12"  ,"/ Position"             );
  ajouteBoutonMode  (bRotScene    ,               true , rotScene1_xpm       , rotScene0_xpm       ,"V"    ,"Point de Vue"           );
  ajouteBoutonMode  (bPosObjet    ,               false, posObjet1_xpm       , posObjet0_xpm       ,"P"    ,"Position Objet"         );
  ajouteBoutonMode  (bRotObjet    ,               false, rotObjet1_xpm       , rotObjet0_xpm       ,"R"    ,"Rotation Objet"         );
  ajouteBoutonMode  (bTaiObjet    ,               false, taiObjet1_xpm       , taiObjet0_xpm       ,"T"    ,"Taille Objet"           );
  ajouteMiniBouton  (bs           ,     0, false, false, s1_xpm              , s0_xpm              ,"Alt+S","Sommet"                 );
  ajouteMiniBouton  (ba           ,  Ti/3, false, false, a1_xpm              , a0_xpm              ,"Alt+A","Arte"                  );
  ajouteMiniBouton  (bf           ,2*Ti/3, true , false, f1_xpm              , f0_xpm              ,"Alt+F","Face"                   );
  ajouteMiniBouton  (bv           ,     0, false, false, v1_xpm              , v0_xpm              ,"Alt+V","Volume"                 );
  ajouteMiniBouton  (bc           ,  Ti/3, false, false, c1_xpm              , c0_xpm              ,"Alt+C","Composante"             );
  ajouteMiniBouton  (bt           ,2*Ti/3, true , false, t1_xpm              , t0_xpm              ,"Alt+T","Tout"                   );
  ajouteMiniBouton  (bx           ,     0, false, false, x1_xpm              , x0_xpm              ,"X"    ,"Composante X"           );
  ajouteMiniBouton  (by           ,  Ti/3, false, false, y1_xpm              , y0_xpm              ,"Y"    ,"Composante Y"           );
  ajouteMiniBouton  (bz           ,2*Ti/3, true , true , z1_xpm              , z0_xpm              ,"Z"    ,"Composante Z"           );
  ajouteBoutonMode  (bAjouteSommet,               false, sommet1_xpm         , sommet0_xpm         ,"S"    ,"Adjonction Sommet"      );
  ajouteBoutonMode  (bAjouteArete ,               false, arete1_xpm          , arete0_xpm          ,"A"    ,"Adjonction Arte"       );
  ajouteBoutonMode  (bAjouteFace  ,               true , face1_xpm           , face0_xpm           ,"F"    ,"Adjonction Face"        );
  ajouteBoutonMode  (bExtrusionM  ,               false, extrusionChemin1_xpm, extrusionChemin0_xpm,"M"    ,"Extrusion Multiple"     );
  
  __dy=0;
  ajouteBoutonAction(bVolFace     ,               false, objFace1_xpm        , objFace0_xpm        ,"Ctl+F","Crer Face"             );
  ajouteBoutonAction(bVolPyram    ,               false, objPyramide1_xpm    , objPyramide0_xpm    ,"Ctl+P","Crer Pyramide"         );
  ajouteBoutonAction(bVolCube     ,               false, objCube1_xpm        , objCube0_xpm        ,"Ctl+C","Crer Cube"             );
  ajouteBoutonAction(bVolSphere   ,               false, objSphere1_xpm      , objSphere0_xpm      ,"Ctl+S","Crer Sphre"           );
  ajouteBoutonAction(bVolTore     ,               true , objTore1_xpm        , objTore0_xpm        ,"Ctl+T","Crer Tore"             );
  
  ajouteBoutonAction(bDuplique    ,               false, duplication1_xpm    , duplication0_xpm    ,"Enter","Dupliquer Objet"        );
  ajouteBoutonAction(bSupprime    ,               false, suppression1_xpm    , suppression0_xpm    ,"Suppr","Supprimer Objet"        );
  ajouteBoutonAction(bDecous      ,               false, decouture1_xpm      , decouture0_xpm      ,"D"    ,"Dcoudre"               );
  ajouteBoutonAction(bFusionne    ,               true , fusion1_xpm         , fusion0_xpm         ,"+"    ,"Fusionner Volumes"      );
  ajouteBoutonAction(bExtrude     ,               true , extrusion1_xpm      , extrusion0_xpm      ,"E"    ,"Extruder Face"          );
  ajouteBoutonAction(bOption      ,               false, option1_xpm         , option0_xpm         ,""     ,"Caf ?"                 );
  //...........................................................................
  // Emplacements:
  dFace       ->move(               0, 0                                  );
  dPyram      ->move(dFace->width()+2, 0                                  );
  dSphere     ->move(               0, dFace->height()                  +2);
  dTore       ->move(               0, dFace->height()+dSphere->height()+4);
  //...........................................................................
  // Connexions:
  connect(bCreation  ,SIGNAL(proprietes(bouton *)),this,SLOT(proprietesBouton (bouton *)));
  
  connect(f->carte() ,SIGNAL(carteModifiee    (superCarte *)),this,SLOT(slotModifiee       (superCarte *)));
  connect(f          ,SIGNAL(raffraichissement(fenetreGL  *)),this,SLOT(slotFenetreModifiee(fenetreGL  *)));
  
  connect(f   ,SIGNAL(boutons    (fenetre *,bool,bool,bool)),
		this,SLOT  (slotBoutons(fenetre *,bool,bool,bool)));
  //...........................................................................
  // Initialisations diverses:
  bOption ->hide();
  mode    ->setCheckable(true);
  sousMode->setCheckable(true);
  options ->setCheckable(true);
  sousMode->setItemChecked( 2,false);
  sousMode->setItemChecked( 3,false);
  sousMode->setItemChecked( 4,false);
  sousMode->setItemChecked( 8,false);
  sousMode->setItemChecked( 9,false);
  sousMode->setItemChecked(10,false);

  options->setItemChecked(0/* vue clate  */,f->getEclate   ());
  options->setItemChecked(1/* facettes     */,f->getShade    ());
  options->setItemChecked(2/* transparence */,f->getBlend    ());
  options->setItemChecked(3/* lighting     */,f->getLighting ());
  options->setItemChecked(4/* antialias    */,f->getAntiAlias());
  
  setCaption("x3gc - Modeleur  base de 3-g-cartes");
  setBackgroundColor(C_MO_FOND);
  barreModes  ->setBackgroundColor(C_BE_FOND);
  barreActions->setBackgroundColor(C_BE_FOND);
  barreParams ->setBackgroundColor(C_MO_FOND);
  
  setMinimumSize(2*Ti+TMINFENETRE+Wd,TMINFENETRE+Hm+He);
  
  clicSousMode(bGeo);
  clicSousMode(bgo);
  clicSousMode(bgt);
  clicSousMode(bgp);
  clicSousMode(bc);
  clicSousMode(bx);
  clicSousMode(by);
  clicSousMode(bz);

  clicMode(bRotScene);
}
//-----------------------------------------------------------------------------
// Destructeur:
//-----------------------------------------------------------------------------
modeleur::~modeleur()
{
  delete x3gc         ;
  delete bt           ;
  delete bc           ;
  delete bv           ;
  delete bf           ;
  delete ba           ;
  delete bs           ;
  delete bz           ;
  delete by           ;
  delete bx           ;
  delete bgp          ;
  delete bgt          ;
  delete bgo          ;
  delete bGeo         ;
  delete bTopo        ;
  delete bOption      ;
  delete bExtrude     ;
  delete bDecous      ;
  delete bSupprime    ;
  delete dTore        ;
  delete dSphere      ;
  delete dPyram       ;
  delete dFace        ;
  delete infos        ;
  delete objets       ;
  delete sousMode     ;
  delete mode         ;
  delete graphe       ;
  delete bVolTore     ;
  delete bVolSphere   ;
  delete bVolCube     ;
  delete bVolPyram    ;
  delete bVolFace     ;
  delete bAjouteFace  ;
  delete bAjouteArete ;
  delete bAjouteSommet;
  delete bPosObjet    ;
  delete bRotObjet    ;
  delete bTaiObjet    ;
  delete bRotScene    ;
  delete bCouture     ;
  delete bCreation    ;
  delete barreParams  ;
  delete barreActions ;
  delete barreModes   ;
  delete mb           ;
  delete bi           ;
  delete be           ;
  delete f            ;
}
//-----------------------------------------------------------------------------
void modeleur::ajouteBoutonMode  (bouton * & B,
						    bool separation,
						    const char ** pm1, const char ** pm0,
						    char * raccourci, char * info)
{
  B = new bouton(QPixmap(pm1),QPixmap(pm0),raccourci,info, barreModes);
  B->setGeometry(0,__dy,Ti,Ti);

  connect(B,SIGNAL(clic(bouton *)),this,SLOT(clicMode(bouton *)));
  connect(B,SIGNAL(texte(QString,QString)),be,SLOT(setMessage(QString,QString)));

  __dy+= Ti;

  if (separation)
    __dy+= Hs;
}

void modeleur::ajouteMiniBouton  (bouton * & B, unsigned int dx, bool endl,
						    bool separation,
						    const char ** pm1, const char ** pm0,
						    char * raccourci, char * info)
{
  B = new bouton(QPixmap(pm1),QPixmap(pm0),raccourci,info, barreModes);
  B->setGeometry(dx,__dy,Ti/3,Ti/3);

  connect(B,SIGNAL(clic(bouton *)),this,SLOT(clicSousMode(bouton *)));
  connect(B,SIGNAL(texte(QString,QString)),be,SLOT(setMessage(QString,QString)));

  if (endl)
    {
	 __dy+= Ti/3;
	 
	 if (separation)
	   __dy+= Hs;
    }
}

void modeleur::ajouteBoutonAction(bouton * & B,
						    bool separation,
						    const char ** pm1, const char ** pm0,
						    char * raccourci, char * info)
{
  B = new bouton(QPixmap(pm1),QPixmap(pm0),raccourci,info, barreActions);
  B->setGeometry(0,__dy,Ti,Ti);

  connect(B,SIGNAL(clic(bouton *)),this,SLOT(clicAction(bouton *)));
  connect(B,SIGNAL(relachement(bouton *)),this,SLOT(relachementBouton(bouton *)));
  connect(B,SIGNAL(texte(QString,QString)),be,SLOT(setMessage(QString,QString)));

  __dy+=Ti;

  if (separation)
    __dy+= Hs;
}
//-----------------------------------------------------------------------------
void modeleur::slotBoutons(fenetre * f, bool b1, bool b2, bool b3)
{
  be->setBoutons(b1,b2,b3);
}

void modeleur::slotModifiee(superCarte * g)
{
  be->setModifiee(g->modifiee());
}

void modeleur::slotFenetreModifiee(fenetreGL * f)
{
  superCarte * g= f->carte();
  
  int
    nb= g->nbBrins(),
    ns= g->nbSommets(),
    e,l;
  
  brin * b= g->getSelection1();
  
  if (b==NULL)
    { e=l=0; }
  else
    {
	 e= g->getEpaisseur();
	 l= b->getSommet()->nbLiens();
    }
  
  bi->setInfos(nb,ns,e,l);
}
//****************************************************************************************************
void modeleur::clicMode(bouton * b)
{
  if (f->working() || b->estSelectionne())
    return;
  
  b->selectionne(true);
  
  if (b==bCreation    ) f->setMode(Creation         ); else bCreation    ->selectionne(false);
  if (b==bCouture     ) f->setMode(Couture          ); else bCouture     ->selectionne(false);
  if (b==bRotScene    ) f->setMode(RotationScene    ); else bRotScene    ->selectionne(false);
  if (b==bPosObjet    ) f->setMode(PositionObjet    ); else bPosObjet    ->selectionne(false);
  if (b==bRotObjet    ) f->setMode(RotationObjet    ); else bRotObjet    ->selectionne(false);
  if (b==bTaiObjet    ) f->setMode(TailleObjet      ); else bTaiObjet    ->selectionne(false);
  if (b==bAjouteSommet) f->setMode(AdjonctionSommet ); else bAjouteSommet->selectionne(false);
  if (b==bAjouteArete ) f->setMode(AdjonctionArete  ); else bAjouteArete ->selectionne(false);
  if (b==bAjouteFace  ) f->setMode(AdjonctionFace   ); else bAjouteFace  ->selectionne(false);
  if (b==bExtrusionM  ) f->setMode(ExtrusionMultiple); else bExtrusionM  ->selectionne(false);
  
  if (b==bCreation    ) be->setMouseInfos("Cration Brin","","Cration Arte");
  if (b==bCouture     ) be->setMouseInfos("Slection Brin","Changer d'Arte","Couture Brins");
  if (b==bRotScene    ) be->setMouseInfos("Angle de Vue","","Zoom");
  if (b==bPosObjet    ) be->setMouseInfos("XY",""   ,"Z");
  if (b==bRotObjet    ) be->setMouseInfos("X" ,"Y"  ,"Z");
  if (b==bTaiObjet    ) be->setMouseInfos("XY","XYZ","Z");
  if (b==bAjouteSommet) be->setMouseInfos("Adjonction Sommet","","");
  if (b==bAjouteArete ) be->setMouseInfos("Slection Sommet","","Adjonction Arte");
  if (b==bAjouteFace  ) be->setMouseInfos("Slection Brin","Dslection","Adjonction Face");
  if (b==bExtrusionM  ) be->setMouseInfos("Slection Face","","Slection Chemin");

  mode->setItemChecked(0, b==bCreation    );
  mode->setItemChecked(1, b==bCouture     );
  mode->setItemChecked(2, b==bRotScene    );
  mode->setItemChecked(3, b==bPosObjet    );
  mode->setItemChecked(4, b==bRotObjet    );
  mode->setItemChecked(5, b==bTaiObjet    );
  mode->setItemChecked(6, b==bAjouteSommet);
  mode->setItemChecked(7, b==bAjouteArete );
  mode->setItemChecked(8, b==bAjouteFace  );
  mode->setItemChecked(9, b==bExtrusionM  );
}

#define R (1.0)
#define r (0.3)
void modeleur::clicAction(bouton * b)
{
  f->carte()->beginUpdate();
  b->selectionne(true);

  brin * s1= f->carte()->getSelection1();
  
  if (b==bVolFace  ) f->carte()->insereFace    (dFace ->meridiens());
  if (b==bVolPyram ) f->carte()->inserePyramide(dPyram->meridiens());
  if (b==bVolCube  ) f->carte()->insereCube();
  if (b==bVolSphere) f->carte()->insereSphere(dSphere->meridiens(),dSphere->paralleles());
  if (b==bVolTore  ) f->carte()->insereTore(dTore->grandRayon(), dTore->petitRayon(),
								    dTore->meridiens (), dTore->paralleles());
  
  if (s1!=NULL)
    {
	 if (b==bDuplique)
	   f->carte()->dupliqueComposante(s1);
	 
	 if (b==bSupprime)
	   f->carte()->supprimeComposante(s1);
	 
	 if (b==bDecous)
	   f->carte()->decoudre(s1);
	 
	 if (b==bFusionne)
	   f->carte()->fusion(s1);

	 if (b==bExtrude)
	   {
		sommet v= f->carte()->normale(s1);
		v/= sqrt(v.norme()); // On sait que normale renvoie un vecteur non nul => pas de division par 0.
		f->carte()->extrusionFace(s1,v,dSphere->meridiens());
	   }
    }

  if (b==bOption)
    {
	 QMessageBox mb;
	 mb.setIconPixmap(QPixmap(option1_xpm));
	 mb.setCaption("x3gc: Caf ?");
	 mb.setText("Dsol: La fonction \"Un caf et l'addition\"\nn'est pas implmente dans cette version de x3gc.");
	 relachementBouton(bOption);
	 mb.exec();
    }
  
  f->carte()->endUpdate();
}
#undef r
#undef R

void modeleur::clicSousMode(bouton * b)
{
  if (f->working())
    return;

  //..................................
  if (b==bTopo || b==bGeo)
    {
	 bGeo ->selectionne(b==bGeo );
	 bTopo->selectionne(b==bTopo);
	 f->setCouturesGeometriques(b==bGeo);
	 
	 sousMode->setItemChecked(0,b==bTopo);
	 sousMode->setItemChecked(1,b==bGeo );
    }
  //..................................
  if (b==bgo || b==bgt || b==bgp)
    {
	 if (b==bgo)
	   {
		bool b= !sousMode->isItemChecked( 2);
		sousMode->setItemChecked( 2,b);
		bgo->selectionne(b);
		f->seto(b);
	   }
	 if (b==bgt)
	   {
		bool b= !sousMode->isItemChecked( 3);
		sousMode->setItemChecked( 3,b);
		bgt->selectionne(b);
		f->sett(b);
	   }
	 if (b==bgp)
	   {
		bool b= !sousMode->isItemChecked( 4);
		sousMode->setItemChecked( 4,b);
		bgp->selectionne(b);
		f->setp(b);
	   }
    }
  //..................................
  if (b==bs || b==ba || b==bf || b==bv || b==bc || b==bt)
    {
	 bs->selectionne(b==bs); sousMode->setItemChecked( 5,b==bs); if (b==bs) f->setSousMode(Sommet    );
	 ba->selectionne(b==ba); sousMode->setItemChecked( 6,b==ba); if (b==ba) f->setSousMode(Arete     );
	 bf->selectionne(b==bf); sousMode->setItemChecked( 7,b==bf); if (b==bf) f->setSousMode(Face      );
	 bv->selectionne(b==bv); sousMode->setItemChecked( 8,b==bv); if (b==bv) f->setSousMode(Volume    );
	 bc->selectionne(b==bc); sousMode->setItemChecked( 9,b==bc); if (b==bc) f->setSousMode(Composante);
	 bt->selectionne(b==bt); sousMode->setItemChecked(10,b==bt); if (b==bt) f->setSousMode(Tout      );
    }
  //..................................
  if (b==bx || b==by || b==bz)
    {
	 if (b==bx)
	   {
		bool b= !sousMode->isItemChecked(11);
		sousMode->setItemChecked(11,b);
		bx->selectionne(b);
		f->setx(b);
	   }
	 if (b==by)
	   {
		bool b= !sousMode->isItemChecked(12);
		sousMode->setItemChecked(12,b);
		by->selectionne(b);
		f->sety(b);
	   }
	 if (b==bz)
	   {
		bool b= !sousMode->isItemChecked(13);
		sousMode->setItemChecked(13,b);
		bz->selectionne(b);
		f->setz(b);
	   }
    }
  //..................................
}
//*****************************************************************************************************
void modeleur::relachementBouton(bouton * b)
{
  b->selectionne(false);
}

void modeleur::proprietesBouton(bouton * b)
{
  if (b==bCreation)
    {
	 dialogXYZ d(this,"x3gc: Crer un Brin");
	 connect(&d,SIGNAL(ajouteBrin(sommet *)),this,SLOT(ajouteBrin(sommet *)));
	 d.exec();
    }
}

void modeleur::appliqueAlpha(int i)
{
  if (f->carte()->getSelection1() && i>=0 && i<=3)
    f->carte()->setSelection1(f->carte()->getSelection1()->getAlpha(i));
}

bool modeleur::menuNouveau()
{
  bool ok=true;
  
  if (f->carte()->modifiee())
    {
	 int choix=
	   QMessageBox::information(this, "x3gc",
						   "Des modifications ont t apportes au graphe.\n"
						   "Voulez-vous les sauvegarder?",
						   "&Sauver", "Ne &pas sauver", "&Annuler",
						   0,2); /* Enter= bouton 0, Echap= bouton 2 */
	 
	 if (choix==0) ok= menuSauver();
      if (choix==2) ok= false;
    }
  
  if (ok)
    {
	 be->setNomFic("");
	 f->carte()->nouvelle();
    }
  
  return ok;
}

void modeleur::menuCharger()
{
  QFileDialog fd(NULL,FILTRE,this,NULL,true);
  fd.setFilter(FILTRE);
  fd.setCaption("x3gc: Ouvrir");
  fd.setMode(QFileDialog::ExistingFile);
  
  bool fin=false;
  while (!fin)
    {
	 if (fd.exec())
	   {
		QFileInfo fi(fd.selectedFile());
		if (fi.isReadable())
		  {
		    int choix;
		    
		    if (f->carte()->modifiee())
			 choix= QMessageBox::information(this, "x3gc",
									   "Des modifications ont t apportes au graphe.\n"
									   "Voulez-vous les sauvegarder?",
									   "&Sauver", "Ne &pas sauver", "&Annuler",
									   0,2); /* Enter= bouton 0, Echap= bouton 2 */
		    else
			 choix= 1;
		    
		    if ((choix==0 && !menuSauver()) || choix==2)
			 return;
		    
		    QString message;
		    f->carte()->beginUpdate();
		    unsigned int result= f->carte()->charger(fi.absFilePath(),message);
		    
		    if (result==0)
			 {
			   be->setNomFic(fi.absFilePath());                           
			   fin=true;
			 }
		    else
			 {
			   message.sprintf("Le fichier <%s> est illisible:\nErreur  la ligne %d.\n\n%s",
						    (const char *) fi.fileName(), result, (const char *) QString(message));
			   QMessageBox::information(this,"x3gc",message,"&Ok");
			 }
		    f->carte()->endUpdate();
		  }
		else
		  QMessageBox::information(this,"x3gc","Vous n'avez pas le droit de lire ce fichier.","&Ok");
	   }
	 else
	   fin=true;
    }
}

void modeleur::menuInserer()
{
  QFileDialog fd(NULL,FILTRE,this,NULL,true);
  fd.setFilter(FILTRE);
  fd.setCaption("x3gc: Insrer");
  fd.setMode(QFileDialog::ExistingFile);
  
  bool fin=false;
  while (!fin)
    {
	 if (fd.exec())
	   {
		QFileInfo fi(fd.selectedFile());
		if (fi.isReadable())
		  {
		    QString message;
		    f->carte()->beginUpdate();
		    unsigned int result= f->carte()->charger(fi.absFilePath(),message,false);
		    
		    if (result==0)
			 fin=true;
		    else
			 {
			   message.sprintf("Le fichier <%s> est illisible:\nErreur  la ligne %d.\n\n%s",
						    (const char *) fi.fileName(), result, (const char *) QString(message));
			   QMessageBox::information(this,"x3gc",message,"&Ok");
			 }
		    f->carte()->endUpdate();
		  }
		else
		  QMessageBox::information(this,"x3gc","Vous n'avez pas le droit de lire ce fichier.","&Ok");
	   }
	 else
	   fin=true;
    }
}

bool modeleur::menuSauver()
{
  if (!be->getModifiee())
    return true;
  
  if (be->getNomFic()=="")
    return menuSauverSous();
  
  if (f->carte()->sauvegarder(be->getNomFic()))
    {
	 be->setModifiee(false);
	 return true;
    }
  else
    {
	 QMessageBox::information(this,"x3gc","Echec lors de la sauvegarde.","&Ok");
	 return false;
    }
}

bool modeleur::menuSauverSous()
{
  QFileDialog fd(NULL,FILTRE,this,NULL,true);
  fd.setFilter(FILTRE);
  fd.setCaption("x3gc: Enregistrer Sous");
  
  while (true)
    {
	 if (fd.exec())
	   {
		QFileInfo fi(fd.selectedFile());
		
		if (fi.extension()=="")
		  fi.setFile(fi.absFilePath()+".3gc");
		
		if (fi.exists() && !fi.isWritable())
		  QMessageBox::information(this,"x3gc","Vous n'avez pas le droit de modifier ce fichier.","&Ok");
		else
		  {
		    if (!fi.exists() || QMessageBox::information(this, "x3gc", "Ce fichier existe dj\n"
											    "Voulez-vous l'craser?",
											    "&Oui", "&Non", NULL,1,1) == 0)
			 {
			   QFile fic(fi.absFilePath());
			   if (!fic.open(IO_WriteOnly))
				QMessageBox::information(this,"x3gc","Vous n'avez pas le droit de crer ce fichier.","&Ok");
			   else
				{
				  fic.close();
				  
				  if (f->carte()->sauvegarder(fi.absFilePath()))
				    {
					 be->setNomFic(fi.absFilePath());
					 be->setModifiee(false);
					 return true;
				    }
				  else
				    {
					 QMessageBox::information(this,"x3gc","Echec lors de la sauvegarde.","&Ok");
					 return false;
				    }
				}
			 }
		  }
	   }
	 else
	   return false;
    }
}

void modeleur::menuQuitter()
{
  if (menuNouveau())
    emit quit();
}

void modeleur::menuBrin       () { clicMode(bCreation    ); }
void modeleur::menuCouture    () { clicMode(bCouture     ); }
void modeleur::menuAngleVue   () { clicMode(bRotScene    ); }
void modeleur::menuPos        () { clicMode(bPosObjet    ); }
void modeleur::menuRot        () { clicMode(bRotObjet    ); }
void modeleur::menuTai        () { clicMode(bTaiObjet    ); }
void modeleur::menuNouvSommet () { clicMode(bAjouteSommet); }
void modeleur::menuNouvArete  () { clicMode(bAjouteArete ); }
void modeleur::menuNouvFace   () { clicMode(bAjouteFace  ); }
void modeleur::menuExtrusionM () { clicMode(bExtrusionM  ); }

void modeleur::menuOFace      () { clicAction(bVolFace  ); bVolFace  ->selectionne(false); }
void modeleur::menuOPyram     () { clicAction(bVolPyram ); bVolPyram ->selectionne(false); }
void modeleur::menuOCube      () { clicAction(bVolCube  ); bVolCube  ->selectionne(false); }
void modeleur::menuOSphere    () { clicAction(bVolSphere); bVolSphere->selectionne(false); }
void modeleur::menuOTore      () { clicAction(bVolTore  ); bVolTore  ->selectionne(false); }

void modeleur::menuDupliquer  () { clicAction(bDuplique ); bDuplique ->selectionne(false); }
void modeleur::menuSupprimer  () { clicAction(bSupprime ); bSupprime ->selectionne(false); }
void modeleur::menuDecoudre   () { clicAction(bDecous   ); bDecous   ->selectionne(false); }
void modeleur::menuFusionner  () { clicAction(bFusionne ); bFusionne ->selectionne(false); }
void modeleur::menuExtruder   () { clicAction(bExtrude  ); bExtrude  ->selectionne(false); }

void modeleur::menuSommet     () { clicSousMode(bs        ); }
void modeleur::menuArete      () { clicSousMode(ba        ); }
void modeleur::menuFace       () { clicSousMode(bf        ); }
void modeleur::menuVolume     () { clicSousMode(bv        ); }
void modeleur::menuComposante () { clicSousMode(bc        ); }
void modeleur::menuTout       () { clicSousMode(bt        ); }

void modeleur::menuX          () { clicSousMode(bx        ); }
void modeleur::menuY          () { clicSousMode(by        ); }
void modeleur::menuZ          () { clicSousMode(bz        ); }

void modeleur::menuTopo       () { clicSousMode(bTopo     ); }
void modeleur::menuGeo        () { clicSousMode(bGeo      ); }

void modeleur::menuCGOri      () { clicSousMode(bgo       ); }
void modeleur::menuCGPos      () { clicSousMode(bgp       ); }
void modeleur::menuCGTai      () { clicSousMode(bgt       ); }

void modeleur::menuAlpha0     () { appliqueAlpha(0); }
void modeleur::menuAlpha1     () { appliqueAlpha(1); }
void modeleur::menuAlpha2     () { appliqueAlpha(2); }
void modeleur::menuAlpha3     () { appliqueAlpha(3); }

void modeleur::menuOrientabilite()
{
  brin * b= f->carte()->getSelection1();

  if (b==NULL)
    return;

  bool o= f->carte()->orientable(b);

  QMessageBox mb;
  mb.setCaption("x3gc: Orientabilit");

  QString m,t,u;
  ensemble e;

  e = f->carte()->orbiteComposante(b);
  if (e.taille()==1) t= "1 brin"  ; else t.sprintf("%d brins"  ,e.taille());

  e= sommets(e);
  if (e.taille()==1) u= "1 sommet"; else u.sprintf("%d sommets",e.taille());

  m.sprintf("Cet objet est compos de %s et de %s.\n",(const char *) t,(const char *) u);

  if (o)
    m+="Il est orientable.";
  else
    m+="Il n'est pas orientable.";

  t.sprintf("\nIl est de genre %d.",f->carte()->genre(b));
  m+=t;

  mb.setText(m);
  mb.exec();
}

void modeleur::menuEclatee()
{
  bool b= !f->getEclate();

  options->setItemChecked(0,b);
  f->setEclate(b);
}

void modeleur::menuFacettes()
{
  bool b= !f->getShade();

  options->setItemChecked(1,b);
  f->setShade(b);
}

void modeleur::menuTransparence()
{
  bool b= !f->getBlend();

  options->setItemChecked(2,b);
  f->setBlend(b);
}

void modeleur::menuLighting()
{
  bool b= !f->getLighting();

  options->setItemChecked(3,b);
  f->setLighting(b);
}

void modeleur::menuAntiAlias()
{
  bool b= !options->isItemChecked(4);
  options->setItemChecked(4,b);
  f->setAntiAlias(b);
}

void modeleur::menuChangerFace()
{
  f->changeFace();
}

void modeleur::menuChangerArete()
{
  f->changeArete();
}

void modeleur::menuQt()
{
  QMessageBox::aboutQt(this);
}

void modeleur::menuAPropos()
{
  aPropos ap(this,"x3gc:  Propos");
  ap.exec();
}

void modeleur::resizeEvent(QResizeEvent * re)
{
  int
    W= re->size().width() ,
    H= re->size().height();
  
  f ->setGeometry(Ti,  Hm   ,W-Wd-Ti-Ti,H-Hm-Hi-He);
  be->setGeometry( 0,H-He   ,W-Wd      ,        He);
  bi->setGeometry(Ti,H-He-Hi,W-Wd-Ti-Ti,     Hi   );
  
  barreModes  ->setGeometry(0      ,Hm  ,Ti  ,H-Hm-He);
  barreActions->setGeometry(W-Wd-Ti,Hm  ,Ti  ,H-Hm-He);
  barreParams ->setGeometry(W-Wd+3 ,Hm+2,Wd-4,dTore->y()+dTore->height()-dFace->y());
}

void modeleur::ajouteBrin(sommet * s)
{
  f->carte()->setSelection1(f->carte()->ajouteBrin(s));
}

void modeleur::keyPressEvent(QKeyEvent * ke)
{
  switch (ke->key())
    {
    case Key_Space:
	 { menuChangerFace(); break; }

    case Key_Agrave:    /*  */
    case Key_0:
	 { appliqueAlpha(0); break; }
    case Key_Ampersand: /* & */
    case Key_1:
	 { appliqueAlpha(1); break; }
    case Key_Eacute:    /*  */
    case Key_2:
	 { appliqueAlpha(2); break; }
    case Key_QuoteDbl:  /* " */
    case Key_3:
	 { appliqueAlpha(3); break; }
	 
    case Key_S:
	 { if (ke->state()==ControlButton) clicSousMode(bs); break; }
    case Key_A:
	 { if (ke->state()==ControlButton) clicSousMode(ba); break; }
    case Key_F:
	 { if (ke->state()==ControlButton) clicSousMode(bf); break; }
    case Key_V:
	 { if (ke->state()==ControlButton) clicSousMode(bv); break; }
    case Key_C:
	 { if (ke->state()==ControlButton) clicSousMode(bc); break; }
    case Key_T:
	 { if (ke->state()==ControlButton) clicSousMode(bt); break; }
    case Key_F7:
	 { if (ke->state()==AltButton) { if (bOption->isVisible()) bOption->hide(); else bOption->show(); } break; }
    }

  if (ke->ascii() == '+')
    {
	 clicAction(bFusionne);
	 bFusionne->selectionne(false);
    }
}

void modeleur::closeEvent(QCloseEvent * ce)
{
  if (f->carte()->modifiee() && !menuNouveau())
    ce->ignore();
  else
    ce->accept();
}

void modeleur::paintEvent(QPaintEvent * pe)
{
  int
    w=          barreParams->width ()   ,
    h= height()-barreParams->height()-Hm;
  
  w-= (w - x3gc->width ())/2;
  h-= (h - x3gc->height())/2;
  
  QPainter p;
  p.begin(this);
  p.setPen(white);
  p.drawPixmap(width()-w,height()-h,*x3gc);
  p.end();
}
