#ifndef _modeleur_h
#define _modeleur_h

#include <qobject.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qpixmap.h>

#include "superCarte.h"
#include "fenetre.h"
#include "bouton.h"
#include "barreEtat.h"
#include "barreInfos.h"

#include "dialogue.h"

class modeleur: public QWidget
{
  Q_OBJECT

 private:
  fenetre    * f ;
  QMenuBar   * mb;
  barreEtat  * be;
  barreInfos * bi;

  QPixmap * x3gc;

  QPopupMenu * graphe, * mode, *sousMode, * objets, * actions, * invo, * options, * infos;

  bouton
    *bCreation    , *bCouture    ,
    *bRotScene    ,
    *bPosObjet    , *bRotObjet   , *bTaiObjet  ,
    *bAjouteSommet, *bAjouteArete, *bAjouteFace, *bExtrusionM,

    *bVolFace , *bVolPyram     , *bVolCube , *bVolSphere, *bVolTore,

    *bDuplique, *bSupprime     , *bDecous  , *bExtrude  , *bFusionne, *bOption,

    *bs, *ba, *bf, *bv, *bc, *bt, *bx, *by, *bz,
    *bTopo, *bGeo, *bgo, *bgt, *bgp;

  unsigned int __dy; // pour la position des icones... utilis uniquement  la cration.

  // Boites de dialogue pour modifier les caractristiques des volumes prdfinis:
  dialogue *dFace, *dPyram, *dSphere, *dTore;

  // Barres Icones:
  QWidget * barreModes, * barreActions, * barreParams;

  void ajouteBoutonMode  (bouton * &,                     bool, const char **, const char **, char *,char *);
  void ajouteMiniBouton  (bouton * &, unsigned int, bool, bool, const char **, const char **, char *,char *);
  void ajouteBoutonAction(bouton * &,                     bool, const char **, const char **, char *,char *);

  void appliqueAlpha(int);

 signals:
  void quit();

 private slots:
  void slotBoutons (fenetre *, bool,bool,bool);
  void slotModifiee(superCarte *);
  void slotFenetreModifiee(fenetreGL *);

 public slots:
  bool menuNouveau      ();
  void menuCharger      ();
  void menuInserer      ();
  bool menuSauver       ();
  bool menuSauverSous   ();
  void menuQuitter      ();
  void menuBrin         ();
  void menuCouture      ();
  void menuAngleVue     ();
  void menuPos          ();
  void menuRot          ();
  void menuTai          ();
  void menuNouvSommet   ();
  void menuNouvArete    ();
  void menuNouvFace     ();
  void menuExtrusionM   ();
  void menuOFace        ();
  void menuOPyram       ();
  void menuOCube        ();
  void menuOSphere      ();
  void menuOTore        ();
  void menuDupliquer    ();
  void menuSupprimer    ();
  void menuChangerFace  ();
  void menuChangerArete ();
  void menuDecoudre     ();
  void menuExtruder     ();
  void menuFusionner    ();
  void menuAlpha0       ();
  void menuAlpha1       ();
  void menuAlpha2       ();
  void menuAlpha3       ();
  void menuQt           ();
  void menuAPropos      ();
  void menuTopo         ();
  void menuGeo          ();
  void menuCGOri        ();
  void menuCGTai        ();
  void menuCGPos        ();
  void menuSommet       ();
  void menuArete        ();
  void menuFace         ();
  void menuVolume       ();
  void menuComposante   ();
  void menuTout         ();
  void menuX            ();
  void menuY            ();
  void menuZ            ();

  void menuEclatee      ();
  void menuFacettes     ();
  void menuTransparence ();
  void menuLighting     ();
  void menuAntiAlias    ();
  void menuOrientabilite();

  void ajouteBrin(sommet *);

  void clicMode         (bouton *);
  void clicAction       (bouton *);
  void clicSousMode     (bouton *);

  void relachementBouton(bouton *);
  void proprietesBouton (bouton *);

 protected:
  void resizeEvent  (QResizeEvent *);
  void keyPressEvent(QKeyEvent    *);
  void closeEvent   (QCloseEvent  *);
  void paintEvent   (QPaintEvent  *);

 public:
  modeleur();
  ~modeleur();
};

#endif
