#include <qbutton.h>
#include <qpainter.h>

#include "monBouton.h"

monBouton::monBouton(const QPixmap & pm1,
				 const QPixmap & pm0,
				 const char * t, const char * m,
				 QWidget * parent)
  : QButton(parent,0)
{
  pointed=false;
  toggled=false;

  touche= new QString(t);
  info  = new QString(m);

  p0= new QPixmap(pm0);
  p1= new QPixmap(pm1);

  setBackgroundColor(QColor(0,0,0));
}

monBouton::~monBouton()
{
  delete p0;
  delete p1;
  delete info;
  delete touche;
}

void monBouton::drawButton(QPainter * p)
{
  int w=width ()-1;
  int h=height()-1;

  p->drawPixmap(0,0,toggled?*p1:*p0,0,0,w+1,h+1);

#define IMAX (1)
  if (pointed || toggled)
    for (int i=0; i<=IMAX; i++)
	 {
	   int k= 64*i/IMAX;

	   p->setPen(QColor(32+k,32+k,32+k));
	   p->drawLine(w-i,1+i,w-i,h-i);
	   p->drawLine(1+i,h-i,w-i,h-i);
	   
	   p->setPen(QColor(255-k,255-k,255-k));
	   p->drawLine(i,i,w-i,i);
	   p->drawLine(i,i,i,h-i);
	 }
#undef IMAX
}

void monBouton::enterEvent(QEvent * fe)
{
  pointed=true;
  repaint(false);
  emit texte(*touche,*info);
}

void monBouton::leaveEvent(QEvent * fe)
{
  pointed=false;
  repaint(false);
  emit texte(QString(""),QString(""));
}

void monBouton::mousePressEvent(QMouseEvent * me)
{
  if (me->button()==LeftButton)
    {
	 if (!toggled)
	   selectionne();
    }

  if (me->button()==RightButton)
    emit proprietes(this);
}

void monBouton::selectionne()
{
  toggled=true;
  repaint(false);
  emit selection(this);
}

void monBouton::deselectionne()
{
  toggled=false;
  repaint(false);
}
