#include <math.h>
//***********************************************************************************
brin * gcarte::insereFace(int n)
{
  if (n<3 || n>100)
    return NULL;

  int i,j;
  sommet * s = new sommet[n];

  // Position des sommets:
  for (i=0; i<n; i++)
    s[i].setxyz(cos(2*M_PI*(i+0.5)/n),sin(2*M_PI*(i+0.5)/n),0);

  // Cration des brins:
  brin * b[2][n];
  for (i=0; i<n; i++)
    for (j=0; j<2; j++)
	 b[j][i]= ajouteBrin( &s[i] );

  // Coutures:
  for (i=0; i<n; i++)
    for (j=0; j<2; j++)
	 {
	   b[j][i]->setAlpha(0,b[1-j][j==0 ? (i+n-1)%n : (i+1)%n]);
	   b[j][i]->setAlpha(1,b[1-j][i]);
	 }

  return b[1][0];
}
//***********************************************************************************
brin * gcarte::inserePyramide(int n) // nombre d'aretes de la base
{
  if (n<3 || n>100)
    return NULL;
  
  int h,i,j;
  
  sommet * s0 = new sommet(0,0,1);
  sommet * s  = new sommet[n];

  // Position des sommets:
  for (i=0; i<n; i++)
    s[i].setxyz(cos(2*M_PI*i/n),
			 sin(2*M_PI*i/n),
			 0);

  // Cration des brins:
  brin * b[8][n];
  for (i=0; i<n; i++)
    for (j=0; j<8; j++)
	 b[j][i]= ajouteBrin( j==4 || j==6 ? s0 : &s[i] );

  // Coutures:
  for (i=0; i<n; i++)
    {
	 h= (i+n-1)%n;
	 j= (i  +1)%n;
	 
	 // Coutures par alpha0:
	 b[0][i]->setAlpha(0,b[1][j]);
	 b[1][i]->setAlpha(0,b[0][h]);
	 b[2][i]->setAlpha(0,b[3][j]);
	 b[3][i]->setAlpha(0,b[2][h]);
	 b[4][i]->setAlpha(0,b[5][i]);
	 b[5][i]->setAlpha(0,b[4][i]);
	 b[6][i]->setAlpha(0,b[7][i]);
	 b[7][i]->setAlpha(0,b[6][i]);
	 // Coutures par alpha1:
	 b[0][i]->setAlpha(1,b[1][i]);
	 b[1][i]->setAlpha(1,b[0][i]);
	 b[2][i]->setAlpha(1,b[5][i]);
	 b[3][i]->setAlpha(1,b[7][i]);
	 b[4][i]->setAlpha(1,b[6][j]);
	 b[5][i]->setAlpha(1,b[2][i]);
	 b[6][i]->setAlpha(1,b[4][h]);
	 b[7][i]->setAlpha(1,b[3][i]);
	 // Coutures par alpha2:
	 b[0][i]->setAlpha(2,b[2][i]);
	 b[1][i]->setAlpha(2,b[3][i]);
	 b[2][i]->setAlpha(2,b[0][i]);
	 b[3][i]->setAlpha(2,b[1][i]);
	 b[4][i]->setAlpha(2,b[6][i]);
	 b[5][i]->setAlpha(2,b[7][i]);
	 b[6][i]->setAlpha(2,b[4][i]);
	 b[7][i]->setAlpha(2,b[5][i]);
    }

  return b[0][0];
}
//***********************************************************************************
brin * gcarte::insereCube()
{
  sommet * s[2][2][2];
  
  int x,y,z,i,j;

  for (x=0; x<2; x++)
    for (y=0; y<2; y++)
	 for (z=0; z<2; z++)
		s[x][y][z]= new sommet(x-0.5,y-0.5,z);

  // Cration des brins:
  brin * b[2][2][2][3][2];
  for (x=0; x<2; x++)
    for (y=0; y<2; y++)
	 for (z=0; z<2; z++)
	   for (j=0; j<2; j++)
		{
		  b[x][y][z][0][j]= ajouteBrin(s[1-x][  y][  z]);
		  b[x][y][z][1][j]= ajouteBrin(s[  x][1-y][  z]);
		  b[x][y][z][2][j]= ajouteBrin(s[  x][  y][1-z]);
		}

  // Coutures:
  for (x=0; x<2; x++)
    for (y=0; y<2; y++)
	 for (z=0; z<2; z++)
	   {
		for (j=0; j<2; j++)
		  {
		    // Coutures par alpha0:
		    b[x][y][z][0][j]->setAlpha(0,b[1-x][  y][  z][0][j]);
		    b[x][y][z][1][j]->setAlpha(0,b[  x][1-y][  z][1][j]);
		    b[x][y][z][2][j]->setAlpha(0,b[  x][  y][1-z][2][j]);
		    // Coutures par alpha2:
		    for (i=0; i<3; i++)
			 b[x][y][z][i][j]->setAlpha(2,b[x][y][z][i][1-j]);
		  }
		// Coutures par alpha1:
		b[1-x][  y][  z][0][0]->setAlpha(1,b[  x][1-y][  z][1][1]);
		b[  x][1-y][  z][1][1]->setAlpha(1,b[1-x][  y][  z][0][0]);

		b[  x][1-y][  z][1][0]->setAlpha(1,b[  x][  y][1-z][2][1]);
		b[  x][  y][1-z][2][1]->setAlpha(1,b[  x][1-y][  z][1][0]);

		b[  x][  y][1-z][2][0]->setAlpha(1,b[1-x][  y][  z][0][1]);
		b[1-x][  y][  z][0][1]->setAlpha(1,b[  x][  y][1-z][2][0]);
	   }

  return b[0][1][1][0][0];
}
//***********************************************************************************
#define R (1) // Rayon de la sphre
brin * gcarte::insereSphere(int m, int p) // mridiens, parallles
{
  if (m<3 || p<1 || m>16 || p>16)
    return NULL;

  int h,i,j,u,v,w,n;

  // Cration des sommets:
  sommet * pn = new sommet(0,0, 2*R); // pole nord
  sommet * ps = new sommet(0,0, 0  ); // pole sud

  sommet * s[p][m];
  coord z,r,alpha;

  for (i=0; i<p; i++)
    {
	 z= -R*cos(M_PI*((coord) (i+1))/((coord) (p+1)));
	 r= sqrt(1-sqr(z/R));

	 for (j=0; j<m; j++)
	   {
		alpha= 2*M_PI*j/m;
		s[i][j]= new sommet(r*cos(alpha),r*sin(alpha),z+R);
	   }
    }

  // Cration des brins:
  brin * nord[m][2], * sud[m][2];
  brin * b[p][m][8];

  for (i=0; i<m; i++)
    for (j=0; j<2; j++)
	 {
	   nord[i][j]= ajouteBrin(pn);
	   sud [i][j]= ajouteBrin(ps);
	 }

  for (i=0; i<p; i++)
    for (j=0; j<m; j++)
	 for (n=0; n<8; n++)
	   // 8 brins par sommets... (ARG!)
	   b[i][j][n]= ajouteBrin(s[i][j]);
  
  // Coutures:
  for (i=0; i<m; i++)
    {
	 h= (i+m-1)%m;
	 j= (i  +1)%m;

	 sud [i][0]->setAlpha(0, b[ 0 ][i][6]); b[ 0 ][i][6]->setAlpha(0,sud [i][0]);
	 sud [i][1]->setAlpha(0, b[ 0 ][i][5]); b[ 0 ][i][5]->setAlpha(0,sud [i][1]);
	 nord[i][0]->setAlpha(0, b[p-1][i][1]); b[p-1][i][1]->setAlpha(0,nord[i][0]);
	 nord[i][1]->setAlpha(0, b[p-1][i][2]); b[p-1][i][2]->setAlpha(0,nord[i][1]);

	 sud [i][0]->setAlpha(1,sud [h][1]);
	 sud [i][1]->setAlpha(1,sud [j][0]);
	 nord[i][0]->setAlpha(1,nord[h][1]);
	 nord[i][1]->setAlpha(1,nord[j][0]);

	 sud [i][0]->setAlpha(2,sud [i][1]);
	 sud [i][1]->setAlpha(2,sud [i][0]);
	 nord[i][0]->setAlpha(2,nord[i][1]);
	 nord[i][1]->setAlpha(2,nord[i][0]);

	 for (v=0; v<p; v++)
	   {
		// Alpha 0:
		b[v][i][0]->setAlpha(0,b[v][h][3]);
		b[v][i][3]->setAlpha(0,b[v][j][0]);
		b[v][i][4]->setAlpha(0,b[v][j][7]);
		b[v][i][7]->setAlpha(0,b[v][h][4]);

		if (v!=0)
		  {
		    b[v][i][5]->setAlpha(0,b[v-1][i][2]);
		    b[v][i][6]->setAlpha(0,b[v-1][i][1]);
		  }

		if (v!=p-1)
		  {
		    b[v][i][1]->setAlpha(0,b[v+1][i][6]);
		    b[v][i][2]->setAlpha(0,b[v+1][i][5]);
		  }
		// Alpha 1:
		b[v][j][0]->setAlpha(1,b[v][j][1]);
		b[v][j][1]->setAlpha(1,b[v][j][0]);
		b[v][j][2]->setAlpha(1,b[v][j][3]);
		b[v][j][3]->setAlpha(1,b[v][j][2]);
		b[v][j][4]->setAlpha(1,b[v][j][5]);
		b[v][j][5]->setAlpha(1,b[v][j][4]);
		b[v][j][6]->setAlpha(1,b[v][j][7]);
		b[v][j][7]->setAlpha(1,b[v][j][6]);
		// Alpha 2:
		b[v][j][0]->setAlpha(2,b[v][j][7]);
		b[v][j][1]->setAlpha(2,b[v][j][2]);
		b[v][j][2]->setAlpha(2,b[v][j][1]);
		b[v][j][3]->setAlpha(2,b[v][j][4]);
		b[v][j][4]->setAlpha(2,b[v][j][3]);
		b[v][j][5]->setAlpha(2,b[v][j][6]);
		b[v][j][6]->setAlpha(2,b[v][j][5]);
		b[v][j][7]->setAlpha(2,b[v][j][0]);
	   }
    }

  return b[p/2][0][1];
}
#undef R
//***********************************************************************************
brin * gcarte::insereTore(coord R, coord r, int m, int p)
{
  if (m<3 || p<1 || m>16 || p>16 || R<r || r<=0)
    return NULL;

  int h,i,j,u,v,w,n;

  // Cration des sommets:
  coord x,z,alpha,beta;
  sommet * s[m][p];

  for (v=0; v<p; v++)
    {
	 alpha= 2*M_PI*v/p;

	 x= R+r*cos(alpha);
	 z= r*(1 + sin(alpha));

	 for (i=0; i<m; i++)
	   {
		beta= 2*M_PI*i/m;
		s[i][v]= new sommet(x*cos(beta), x*sin(beta), z);
	   }
    }
  // Cration des brins:
  brin * b[m][p][8];
  for (i=0; i<m; i++)
    for (v=0; v<p; v++)
	 for (n=0; n<8; n++)
	   b[i][v][n]= ajouteBrin(s[i][v]);

  // Coutures:
  for (i=0; i<m; i++)
    {
	 h= (i+m-1)%m;
	 j= (i+  1)%m;

	 for (v=0; v<p; v++)
	   {
		u= (v+p-1)%p;
		w= (v+  1)%p;

#define SYM (n<4?(n<2?(n==0?3:6):(n==2?5:0)):(n<6?(n==4?7:2):(n==6?1:4)))
#define DX  ((( n==0 || n==7 ? 1 : (n==3 || n==4 ? m-1 : 0 )) + i) % m)
#define DY  ((( n==1 || n==2 ? 1 : (n==5 || n==6 ? p-1 : 0 )) + v) % p)
		for (n=0; n<8; n++)
		  {
		    b[i][v][n]->setAlpha(0,b[DX][DY][SYM]);
		    b[i][v][n]->setAlpha(1,b[i][v][n ^ 1]);
		    b[i][v][n]->setAlpha(2,b[i][v][n ^ (7-4*(((n+1)/2)%2))]);
		  }
#undef DY
#undef DX
#undef SYM
	   }
    }

  return b[0][0][0];
}
//***********************************************************************************
