#ifndef _sommet_h
#define _sommet_h

#include <qobject.h>
#include "base.h"

class sommet: public QObject
{
  Q_OBJECT 

 private:
  coord x,y,z;
  // nombre de brins qui pointent sur ce sommet:
  unsigned int n;

  void creation(coord,coord,coord);
 
 signals:
  // signal mis lorsqu'il n'y a plus de brin qui pointe vers le sommet
  // (=> destruction du sommet par la gcarte)
  void isole(sommet *);
  // signal mis lorsque le sommet est dplac ou dtruit:
  // (dans le cas o il est dtruit, le paramtre vaut NULL)
  void modifie(sommet *);

 public:
  sommet();
  sommet(const coord, const coord, const coord);
  sommet(const sommet &);
  ~sommet();

  void setx(const coord);
  void sety(const coord);
  void setz(const coord);

  void setxyz(const coord, const coord, const coord);

  coord getx() const;
  coord gety() const;
  coord getz() const;

  // Pour modifier le nombre de brins qui pointent sur le sommet:
  unsigned int attache();
  unsigned int detache();

  unsigned int nbLiens() const;

  sommet & operator= (const sommet &);
  sommet & operator+=(const sommet &);
  sommet & operator-=(const sommet &);

  sommet & operator*=(const coord);
  sommet & operator/=(const coord);

  sommet & operator*(const coord);
  sommet & operator/(const coord);

  bool operator==(const sommet &) const;
  bool operator!=(const sommet &) const;

  sommet & operator+(const sommet &) const;
  sommet & operator-(const sommet &) const;
  sommet & operator*(const sommet &) const; // produit vectoriel
  sommet & produit  (const sommet &) const; // produit composante par composante

  coord norme() const;
};

sommet & operator*(const coord, sommet &);

#endif
