#ifndef _superCarte_h
#define _superCarte_h

#include <qobject.h>

#include "ensemble.h"
#include "gcarte.h"

class superCarte: public gcarte
{
  Q_OBJECT

 private:
  // Brin point par la souris; son paisseur:
  brin * pbrin;
  int epaisseur;
  // Pour l'affichage de la slection:
  ensemble sbrin1, sface1, svolume1, scomposante1;
  // Pour l'affichage de la couture en cours:
  ensemble sbrin2, sface2;
  // Le reste des brins:
  ensemble sreste;
  // Tout a dans une liste (cela forme une liste de listes...):
  ensemble tout;

  // Pour l'affichage des normales:
  bool   ffermee1,        ffermee2;
  sommet bary1, normale1, bary2, normale2;

  // Pour les mises--jour:
  unsigned int update;
  bool cm /* carteModifiee */,ns /* nouvelleSelection */;
  void majNormales();
  void emitCarteModifiee();
  void emitNouvelleSelection();

  void supprimeDoublons(ensemble &);
  void epure(ensemble &, ensemble &);

  void setSelection(brin *, brin *, bool);

 private slots:
  void carteModifiee(gcarte *);

 signals:
  void carteModifiee(superCarte *);
  void nouvelleSelection(superCarte *);

 public:
  superCarte();
  ~superCarte();

  brin   * getSelection1();
  brin   * getSelection2();
  ensemble getSelections();
  brin   * getBrinPointe();

  void setSelection1(brin *, bool = false);
  void addSelection1(brin *);
  void setSelection2(brin *, bool = false);
  void setBrinPointe(brin *);

  unsigned int getEpaisseur() const;
  const ensemble * classesBrins() const;

  // Pour l'affichage des normales:
  bool   faceFermee1() const;
  bool   faceFermee2() const;
  sommet barycentreFace1() const;
  sommet barycentreFace2() const;
  sommet normaleFace1() const;
  sommet normaleFace2() const;

  // Pour les mises--jour:
  void beginUpdate();
  void endUpdate();

  // Surcharges pour mise  jour des slections:
  void nouvelle();
  unsigned int charger(const QString, QString &, bool =true); // nom de fichier, message d'erreur, vidage pralable du graphe.

  brin * insereFace(int);
  brin * inserePyramide(int);
  brin * insereCube();
  brin * insereSphere(int,int);
  brin * insereTore(coord,coord,int,int);

  brin * dupliqueComposante(brin *);
  void   supprimeComposante(brin *);

  void   ajouteSommet(brin *, sommet);
  void   ajouteArete (brin *, brin *);
  brin * ajouteFace  (ensemble);

  bool   coudre(brin *,brin *, bool =false, bool =false, bool =false);
  brin * decoudre(brin *);  
  brin * extrusionFace    (brin *, sommet  , const unsigned int);
  brin * extrusionMultiple(brin *, brin   *);
  brin * coutureParBord(brin *, brin *);
  brin * fusion(brin *);

  brin * ajouteBrin(sommet *);
  void   supprimeBrin(brin *);
};

#endif
