#include <stdlib.h>
#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include <math.h>

GLdouble *normal;
double intensity1,intensity2;
double 	lo1[3] = {-1.,.2,0.},
		lp1[3] = {2.,0.3,0.5},
		r1 = 0.45,			// light color
		g1 = 0.95,
		b1 = 0.45;
double 	lo2[3] = {0.5,0.,-1.},
		lp2[3] = {-2.,0.3,1.},
		r2 = 0.4,			// light color
		g2 = 0.50,
		b2 = 0.95;
double 	lo3[3] = {0.5,-0.5,1.},
		lp3[3] = {-2.,0.3,1.},
		r3 = 0.2,			// light color
		g3 = 0.,
		b3 = 0.;

		
int light;

///////////

double ps(double *v1,double *v2)
{
	return 	v1[0]*v2[0] +
			v1[1]*v2[1] +
			v1[2]*v2[2];
}

double sqrd(double d) { return d*d; }

double dist(double *p1,double *p2)
{
	return sqrt(sqrd(p1[0]-p2[0])+
				sqrd(p1[1]-p2[1])+
				sqrd(p1[2]-p2[2]));
}

double *add(double *v1,double *v2)
{
	double *v = malloc(sizeof(double)*3);
	v[0] = v1[0]+v2[0];
	v[1] = v1[1]+v2[1];
	v[2] = v1[2]+v2[2];
	return v;
}


double *sub(double *v1,double *v2)
{
	double *v = malloc(sizeof(double)*3);
	v[0] = v1[0]-v2[0];
	v[1] = v1[1]-v2[1];
	v[2] = v1[2]-v2[2];
	return v;
}

void norm(double *v)
{
//	double *r = malloc(sizeof(double)*3),
	double	d = sqrt(	sqrd(v[0])+
						sqrd(v[1])+
						sqrd(v[2]));
/*	r[0] = v[0] / d;
	r[1] = v[1] / d;
	r[2] = v[2] / d;
	return r;*/
	v[0] /= d;
	v[1] /= d;
	v[2] /= d;	
}

///////////		

double LightPoint(double *v)
{
	double f1=0.5,f2=0,f3=0;
	if (light!=0) {
	// distance function
//	f1 = 3*sqrd(sqrd( (1-(dist(v,lp1)/5)) ));
//	f2 = 3*sqrd(sqrd( (1-(dist(v,lp2)/5)) ));
	// point lighting
//	f = ps(norm(sub(lp,v)),normal);
//	printf("%f,%f,%f\n",(v+3)[0],(v+3)[1],(v+3)[2]);

//	direction lighting	
	norm(v+3);
	f1 = fabs(ps(v+3,lo1));
	f2 = fabs(ps(v+3,lo2));
//	f3 = fabs(ps(v+3,lo3));
	}
	
	glColor4d(	(r1*(f1+0.25)+r2*(f2+0.25)+r3*(f3+0.25))/1.,
				(g1*(f1+0.25)+g2*(f2+0.25)+g3*(f3+0.25))/1.,
				(b1*(f1+0.25)+b2*(f2+0.25)+b3*(f3+0.25))/1.,
				0.3);
}


void Begin(GLenum t)
{
	glBegin(t);
}

void Vertex(void *v)
{
	LightPoint(v);
	glVertex3dv((double*)v);
}

void End()
{
	glEnd();
}


void tShade(int nb,GLdouble *v,int l)
{
	int i;
//	GLUtesselator *tess;
	GLdouble *p;
	
//	normal = norm(n);
	norm(lo1);
	norm(lo2);
	norm(lo3);
	
	light = l;
	
/*	intensity1 = -ps(normal,lo1);
	intensity2 = -ps(normal,lo2);*/
	
//	glColor4d(r1*intensity1,g1*intensity1,b1*intensity1,0.3);	
	
	// Triangles
	
/*	if (nb==3) {
		glBegin(GL_TRIANGLES);
			LightPoint(v);
			glVertex3dv(v);
			LightPoint(v+3);			
			glVertex3dv(v+3);
			LightPoint(v+6);			
			glVertex3dv(v+6);
		glEnd();
		
/*	for (i=0;i<nb;i++)
//	printf("%f,%f,%f\n",v[3*i],v[3*i+1],v[3*i+2]);	*
	}
	
	// Quads
	
	if (nb==4) {
		glBegin(GL_QUADS);
			LightPoint(v);			
			glVertex3dv(v);
			LightPoint(v+3);			
			glVertex3dv(v+3);
			LightPoint(v+6);			
			glVertex3dv(v+6);
			LightPoint(v+9);			
			glVertex3dv(v+9);
		glEnd();

	}
*/	
	// More...
	
//	if (nb>4)
	{
	p = v+6;
	for (i=0;i<nb-2;i++) {
/*		glBegin(GL_LINES);
			glColor4d(1,1,1,1);
			glVertex3dv(p);
			glVertex3dv(add(p,p+3));
		glEnd();*/
		glBegin(GL_TRIANGLES);
			LightPoint(v);
			glVertex3dv(v);
			LightPoint(p);
			glVertex3dv(p);
			LightPoint(p+6);
			glVertex3dv(p+6);
		glEnd();
		p+=6;
	
	
/*	tess = gluNewTess();	
	gluTessCallback(tess,GLU_TESS_BEGIN, Begin );
	gluTessCallback(tess,GLU_TESS_VERTEX,Vertex);
	gluTessCallback(tess,GLU_TESS_END,End);
				
	gluTessBeginPolygon(tess,NULL);
		gluTessBeginContour(tess);
			for (i=0;i<nb;i++)
				gluTessVertex(tess,v+3*i,v+3*i);
		gluTessEndContour(tess);
	gluTessEndPolygon(tess);
	
	gluDeleteTess(tess);*/
	}}
//	printf("\n\n");
}
